<?php
ini_set('display_errors',1);
ini_set('display_startup_erros',1);
error_reporting(E_ALL);
//---------------------[Area de funcoes]
function str_clear($str,$type){
    $ret="false";
    if($type=="str"){
        $str=preg_replace("#[^0-9|A-Z|a-z|\ |\_|\-]#", "", $str);
        $str=preg_replace("# #", "_", $str);
        $ret=substr($str, 0, 128);
    }
    if($type=="name"){
       $str=preg_replace("#[^0-9|A-Z|a-z|\ |\_|\-]#", "", $str);
       $str=preg_replace("# #", "_", $str);
       $ret=substr($str, 0, 48);
   }
    if($type=="serial"){
        
        $str=strtoupper($str);
        $str=preg_replace("#[^0-9|A-Z]#", "", $str);
        $ret=$str;
    }
    if($type=="ip"){
        $str=preg_replace("#[^0-9\/\.]#", "", $str);
        $ret=$str;
    }
    if($type=="vlan"){
        if($str!=""){
            $str=preg_replace("#[^0-9]|any#", "", $str);
        }else{
            $str="any";
        }
        $ret=$str;
    }
    if($type=="cos"){
        if($str!=""){
            $str=preg_replace("#[^0-7]|any#", "", $str);
        }else{
            $str="any";
        }
        if($str>=0 and $str<=7){
            $ret=$str;
        }
    }
    if($type=="tcont"){
        $str=preg_replace("#[^1-6]#", "", $str);
        if($str>=1 and $str<=6){
            $ret=$str;
        }
    }
    if($type=="gem"){
        $str=preg_replace("#[^1-6]#", "", $str);
        $ret=$str;
    }
    if($type=="priority"){
        $str=preg_replace("#[^0-7]#", "", $str);
        $ret=$str;
    }
    return $ret;
}
function mount_code($code,$params){
    foreach ($params as $k => $v) {
        if($v!=""){
        $code=str_replace("{".$k."}",$v,$code);
        }
    }

    
    return $code;
}
function mount_clear($code,$params){
    $code2="";
    $lines=preg_split('#\n#',$code);
    $qlines=sizeof($lines);
    for ($i = 0; $i <=$qlines-1; $i++) {
        $line=$lines[$i];
        if(strpos($line,'{')===false){
            $code2=$code2.$line."\n";
        }
    }
    return $code2;
}
function make_code_onu_interfacexxxxxxxxxxx($params,$opc){
    $code="";
    $ethx="";
    for ($i = 1; $i<=4; $i++) {
        $shutdown="\n   shutdown";
        $iface="eth".$i."_";
        $cfg="";
        if(isset($params[$iface."mode"])){
            
            $shutdown="\n   no shutdown";
            if($params[$iface."mode"]!="Veip"){

                $ethx="\n  ethernet {$i}   {{$iface}cfg}\n   native vlan vlan-id {{$iface}nvlan}\n   native vlan cos {{$iface}ncos}\n   mac-limit {{$iface}lmac}\n   description {{$iface}desc}";
                //$ethx=str_replace("{eth_","{".$iface,$eth);
                    
                if($params[$iface."mode"]=="1"){
                    //$params[$iface."cfg"] = "\n   negotiation".$shutdown;
                    $cfg= "\n   negotiation".$shutdown;
                }
                if($params[$iface."mode"]=="2"){
                    $params[$iface."cfg"] = "\n   no negotiation\n   speed 1000 duplex full".$shutdown;
                }
                if($params[$iface."mode"]=="3"){
                    $params[$iface."cfg"] = "\n   no negotiation\n   speed 1000 duplex half".$shutdown;
                }
                if($params[$iface."mode"]=="4"){   
                    $params[$iface."cfg"] = "\n   no negotiation\n   speed 100 duplex full".$shutdown;
                }
                if($params[$iface."mode"]=="5"){
                    $params[$iface."cfg"] = "\n   no negotiation\n   speed 100 duplex half".$shutdown;
                }
                if($params[$iface."mode"]=="6"){
                    $params[$iface."cfg"] = "\n   no negotiation\n   speed 10 duplex full".$shutdown;
                }
                if($params[$iface."mode"]=="7"){
                    $params[$iface."cfg"] = "\n   no negotiation\n   speed 10 duplex half".$shutdown;
                }
                if($params[$iface."mode"]=="8"){
                    $params[$iface."cfg"] = "\n   shutdown";
                }

                if($params[$iface."mode"]=="9"){
                    $ethx="\n  veip 1\n   native vlan vlan-id {eth1_nvlan}\n   native vlan cos {eth1_ncos}\n  !";
                }
                if($params[$iface."mode"]==""){
                    $ethx="\n  no ethernet ".$i;
                }else{
                    $ethx="\n  no ethernet ".$i.$ethx."\n  !";
                }
    
            }
            $code=$code.$ethx;
            //$code=str_replace("{eth1_cfg}",$cfg,$code);
        }
        
        
        //$code=str_replace("{eth1_cfg}",$cfg,$code);
    }
    

    $code=mount_code($code,$params);
    $code=mount_clear($code,$params);
    
    return $code;
}
function make_code_sp($params,$opc){
    $code="";
    for ($i = 1; $i <=4; $i++) {
        
        $iface="eth".$i."_";
        $inner="";
        if(isset($params[$iface."inner"]) and $params[$iface."action"]=="add"){
            $inner=$params[$iface."inner"];
            $inner=" inner-vlan replace vlan-id ".$inner;
        }
        if(isset($params[$iface."enable"])){
            if($params[$iface."nvlan"]==""){
                $params[$iface."vlan"]="any";
            }
            $code=$code."\nservice-port {{$iface}sp} gpon {pon} onu {onu} gem {{$iface}gem} match vlan vlan-id {{$iface}nvlan} action vlan {{$iface}action} vlan-id {{$iface}outvlan}".$inner." ;";
        }
    }
    $code=mount_code($code,$params);
    $code=mount_clear($code,$params);
    return $code;
}
function make_code_onu($params,$opc){
    $params["name"]=str_clear($params["name"],"str");
    $ipv4="";
    if(isset($params["ipv4_mode"]) and $params["ipv4_mode"]=="static"){
        $ipv4="\n  ipv4 static address {ipv4_ip} default-gateway {ipv4_gw}";
    } 
    $network="\n  ipv4 vlan vlan-id {ipv4_vlan} cos {ipv4_cos}".$ipv4;
    $ethernet=make_code_onu_interface($params,$opc);
    $code="interface gpon {pon}\n onu {onu}\n  name {name}\n  serial-number {serial}\n  line-profile {lp}".$network.$ethernet." !\n!";
    $code=mount_code($code,$params);
    $code=mount_clear($code,$params);
    //$code=preg_replace("#\n\n#", "\n",$code);
    return $code;
}
function code2html($code){
    $x=str_replace("\n","<br>",$code);
    $x="<pre>".$x."</pre>";
    return $x;
}


function make_code_onu_interface($params,$opc){
    $code="";
    $ethx="";
    for ($i = 1; $i<=4; $i++) {
        $shutdown="\n   shutdown";
        $iface="eth".$i."_";
        $cfg="";
        if(isset($params[$iface."mode"])){
            
            $shutdown="\n   no shutdown";

            //if($params[$iface."mode"]!="Veip"){

                $ethx="\n  ethernet {$i}   {{$iface}cfg}\n   native vlan vlan-id {{$iface}nvlan}\n   native vlan cos {{$iface}ncos}\n   mac-limit {{$iface}lmac}\n   description {{$iface}desc}";
              
                    
                if($params[$iface."mode"]=="1"){
                    //$params[$iface."cfg"] = "\n   negotiation".$shutdown;
                    $cfg= "\n   negotiation".$shutdown;
                }
                if($params[$iface."mode"]=="2"){
                    $params[$iface."cfg"] = "\n   no negotiation\n   speed 1000 duplex full".$shutdown;
                }
                if($params[$iface."mode"]=="3"){
                    $params[$iface."cfg"] = "\n   no negotiation\n   speed 1000 duplex half".$shutdown;
                }
                if($params[$iface."mode"]=="4"){   
                    $params[$iface."cfg"] = "\n   no negotiation\n   speed 100 duplex full".$shutdown;
                }
                if($params[$iface."mode"]=="5"){
                    $params[$iface."cfg"] = "\n   no negotiation\n   speed 100 duplex half".$shutdown;
                }
                if($params[$iface."mode"]=="6"){
                    $params[$iface."cfg"] = "\n   no negotiation\n   speed 10 duplex full".$shutdown;
                }
                if($params[$iface."mode"]=="7"){
                    $params[$iface."cfg"] = "\n   no negotiation\n   speed 10 duplex half".$shutdown;
                }
                if($params[$iface."mode"]=="8"){
                    $params[$iface."cfg"] = "\n   shutdown";
                }

                if($params[$iface."mode"]=="9"){
                    $ethx="\n  veip 1\n   native vlan vlan-id {eth1_nvlan}\n   native vlan cos {eth1_ncos}\n  !";
                }
    
            //}
            $code=$code.$ethx;
            
        }
        

    }
    die($code);

    $code=mount_code($code,$params);
    $code=mount_clear($code,$params);
    
    return $code;
}

function make_code_onu_template($template,$pon,$serial,$name,$params){
    $p=$params;
    $p["pon"]=$pon;
    $p["serial"]=$serial;
    $p["name"]=$name;
    $p["onu"]="126";
    $p["lp"]="BER";
   
    $code=make_code_onu($p,"");
    return $code;
}



//---------------------[Area de Variaveis]


    $k["pon"]="1/1/8";
    $k["onu"]="119";
    $k["serial"]="DACM00010369";
    $k["name"]="Jose A Domingos";
    $k["lp"]="BRIDGE";
    
    $k["ipv4_mode"]="static";
    $k["ipv4_ip"]="192.168.9.9/24";
    $k["ipv4_gw"]="192.168.9.1";
    $k["ipv4_vlan"]="3001";
    $k["ipv4_cos"]="5";


    $k["eth1_enable"]="1";
    $k["eth1_mode"]="Auto";
    $k["eth1_lmac"]="11";
    $k["eth1_nvlan"]="101";
    $k["eth1_ncos"]="1";
    $k["eth1_sp"]="1001";
    $k["eth1_gem"]="1";
    $k["eth1_outvlan"]="111";
    $k["eth1_action"]="add";
    $k["eth1_inner"]="";
    

    $k["eth2_enable"]="Y";
    $k["eth2_mode"]="100Mbps - Full Duplex";
    $k["eth2_lmac"]="22";
    $k["eth2_nvlan"]="102";
    $k["eth2_ncos"]="2";

    
    $k["eth3_enable"]="";
    $k["eth3_mode"]="100Mbps - Half Duplex";
    $k["eth3_lmac"]="33";
    $k["eth3_nvlan"]="103";
    $k["eth3_ncos"]="3";


    $k["eth4_enable"]="";
    $k["eth4_mode"]="10Mbps - Half Duplex";
    $k["eth4_lmac"]="44";
    $k["eth4_nvlan"]="104";
    $k["eth4_ncos"]="4";

///////////////////////////////////////////////////////

    $kc["ipv4_mode"]="static";
    $kc["ipv4_ip"]="192.168.9.9/24";
    $kc["ipv4_gw"]="192.168.9.1";
    $kc["ipv4_vlan"]="3001";
    $kc["ipv4_cos"]="5";


    $kc["eth1_enable"]="1";
    $kc["eth1_mode"]="Auto";
    $kc["eth1_lmac"]="11";
    $kc["eth1_nvlan"]="101";
    $kc["eth1_ncos"]="1";
    $kc["eth1_sp"]="1001";
    $kc["eth1_gem"]="1";
    $kc["eth1_outvlan"]="111";
    $kc["eth1_action"]="add";
    $kc["eth1_inner"]="";


    $code1=make_code_onu_template("Template - Bridge","1/1/8","DACM333333","Onu teste",$kc);
    echo $code1;
    die("fim");
    /*

    $code1=make_code_onu($k);


 //   echo $code;

    $code2=make_code_sp($k);
    //echo "<pre>";
    $code=$code1.$code2;
    
    $x=str_replace("\n","<br>",$code);
    $x="<pre>".$x."</pre>";
    $ret["err"]="erro";
    $ret["title"]="Gerador de Codigo";
    $ret["data"]=$x;
    $ret["msg"]="Erro Aqui";
    //echo json_encode($ret);
    //echo $code;

*/
    function make_code_json($resource,$params,$opc){
        $code_onu=make_code_onu($params);
        $code_sp=make_code_sp($params);
        $code=$code_onu.$code_sp;
        $html="<pre>".$code."</pre>";
        $ret["html_code"]=$html;
        $ret["msg"]=$html;
        $ret["title"]="Gerador de Codigo2";
        $ret["err"]="erro";
        return json_encode($ret);
    }

    //--------------------------------------[Programa Principal]
    $p=$_GET;
    $opc="I";
    if(isset($p["oper"]) and isset($p["cmd"])){
        $oper=$p["oper"];
        $cmd=$p["cmd"];
        if ($cmd=="cfg_onu_template"){
            $debug="<pre>".print_r($p,true)."</pre>";
            $code="testevvvv jose";
            $debug=make_code_onu($p);
            $html="<pre>".$code."</pre>";
            $ret["html_code"]=$html;
            $ret["msg"]=$html;
            $ret["title"]="Gerador de Codigo";
            $ret["debug"]=$debug;
            $ret["err"]="ok";
            echo json_encode($ret);
        }

/*
        die("fim");
        $oper=$p["oper"];
        $cmd=$p["cmd"];
        if($cmd="cfg_onu"){
            if($p["dst_onu"]!=""){
                //Trocar de Posicao da Onu
            }
            if($p["src_onu"]!=""){
                $p["onu"]=$p["src_onu"];
            }
            $p["eth1_enable"]="1";
        }
        $code_onu=make_code_onu($p,$opc);       
        $code_interfaces=make_code_onu_interface($p,$opc);
        $code_service_ports=make_code_sp($p,$opc);
        $x=code2html($code_onu);
        die($x);
        echo "<pre>";
        print_r($p);
        echo "</pre>";


        */
    }else{
        die("Falta Paramtros Minimos.");
    }
//  $x=make_code_json("onu",$_GET,"i");
    // echo $x;
    
    //function make_template($resource,$params){
    
    //}
  

?>