<?php
//die("geqkwejrkqwerqwer");
//include_once("lib.php");
function dm_sync_discovery($olt_id){
    $last_update=date('Y-m-d H:i:s');
    $ret=ERR_05;
    if($olt_id!=""){
        $cmd='show interface gpon discovered-onus | nomore | include "     " ;';
        $r=dm_cmd($olt_id,$cmd);
        $lines=preg_split('#\n#',$r);
        $qlines=sizeof($lines);
        $arr1=array();
        DB::query('DELETE FROM '.TBL_DISCOVERY.' WHERE olt_id="'.$olt_id.'"');
        
        for ($i = 0; $i <=$qlines-1; $i++) {
            $b=trim(preg_replace('/( )+/', " ",$lines[$i]));
            if(strpos($b,'/')!==false){
                $line=preg_split("# #",$b);
                $pon_dst=$line[0];
                $serial=$line[1];

                $row = DB::queryFirstRow('select pon_id,onu_id,onu_name from '.TBL_ONU.' where onu_serial="'.$serial.'" limit 1;');
                $pon_src="";
                $info=$pon_dst;
                $onu_id=$row["onu_id"];
                if(isset($row)){
                    $pon_src=$row["pon_id"];
                    $info=$info." | ".$pon_src." - ".str_replace('_'," ",$row["onu_name"]);
                }
                DB::insert(TBL_DISCOVERY, [
                    'olt_id'=>$olt_id,
                    'onu_serial'=>$serial,
                    'pon_src'=>$pon_src,
                    'onu_src'=>$onu_id,
                    'pon_dst'=>$pon_dst,
                    'info'=>$info,
                    'last_update'=>$last_update,
                ]);
            }
        }
        
    }
}
function onu_delete2($olt,$pon,$onu){
    $code_in='interface gpon '.$pon."\n no onu ".$onu."\n!";
    $code_spo="";
    $code_ant="";
    $sql='select * from '.TBL_SP.' where olt_id="'.$olt.'" and pon_id="'.$pon.'" and onu_id="'.$onu.'";';
    $results = DB::query($sql);
    foreach ($results as $row) {   
        $code_spo=$code_spo."\nno service-port ".$row["sp"]." ; top ;";
        $code_ant=$code_ant."\nanti-ip-spoofing ; no interface service-port-".$row["sp"]." ; top ;";
    }
    return $code_in.$code_spo.$code_ant;
}

function spcode($pon,$onu,$gem){
    $arr_pon=explode("/",$pon);
    $qt=sizeof($arr_pon);
    $pon=$arr_pon[$qt-1];
    
    $gem=str_clear($gem,'num');
    $onu=str_clear($onu,"num");
    $pon=str_clear($pon,"num");
    $BT_gem=$gem<<0;
    $BT_pon=$pon<<16;
    $BT_onu=$onu<<8;
    $BT_code=$BT_onu+$BT_pon+$BT_gem;
    return $BT_code;
}
function make_onu($code_in,$p,$make=false){ // $p=Array de Opcoes, $make=true mostra o codigo pronto, $make=false
    $code=$code_in."interface gpon {pon}\n onu {onu}\n  serial-number {serial}\n  name {name}\n  {profiles}\n  {ipv4}\n  {ethx}\n !\n!\n{service_port}\n{anti_ip_spoofing}";
    if($make==false){
        return $code;
    }
    if(isset($p["pon"]) and isset($p["onu"]) and isset($p["serial"])){
        $p["pon"]=str_clear($p["pon"],"pon");
        $p["onu"]=str_clear($p["onu"],"onu");
        $p["name"]=str_clear($p["name"],"name");
        $p["serial"]=str_clear($p["serial"],"serial");
        ///onu<<8
        $code=str_replace("{pon}",$p["pon"],$code);
        $code=str_replace("{onu}",$p["onu"],$code);
        $code=str_replace("{serial}",$p["serial"],$code);
        $code=str_replace2("{name}",$p["name"],$code);
        return $code;
    }else{
        die("Falta Parametros minimos, pon,onu,serial");
    }
}
function make_anti_ip_spoofing($code_in,$p,$make=false){
    $spo["0"]="";
    $spo["1"]="all";
    $spo["4"]="ipv4-all";
    $spo["6"]="ipv6-all";
    $anti="anti-ip-spoofing";
    $code="";
    $code=$code."{eth0_spoof}\n interface service-port-{eth0_sp}\n  allowed-ip {eth0_spoof}\n {eth0_close}\n{eth0_close}";
    $code=$code."\n{eth1_anti}\n interface service-port-{eth1_sp}\n  allowed-ip {eth1_spoof}\n {eth1_close}\n{eth1_close}";
    $code=$code."\n{eth2_anti}\n interface service-port-{eth2_sp}\n  allowed-ip {eth2_spoof}\n {eth2_close}\n{eth2_close}";
    $code=$code."\n{eth3_anti}\n interface service-port-{eth3_sp}\n  allowed-ip {eth3_spoof}\n {eth3_close}\n{eth3_close}";
    $code=$code."\n{eth4_anti}\n interface service-port-{eth4_sp}\n  allowed-ip {eth4_spoof}\n {eth4_close}\n{eth4_close}";

    if($make==false){
        $code=str_replace("{anti_ip_spoofing}",$code,$code_in);
        return $code;
    }   


    if($p["eth0_spoof"]!=""){
        $p["eth0_spoof"]=(isset($p["eth0_spoof"])?$p["eth0_spoof"]:"");
        $p["eth0_spoof"]=$spo[$p["eth0_spoof"]];
        $code=str_replace("{eth0_spoof}",$p["eth0_spoof"],$code);
        $code=str_replace("{eth0_sp}",spcode($p["pon"],$p["onu"],$p["eth0_gem"]),$code);
        $code=str_replace("{eth0_close}","!",$code);
        $code=str_replace("{eth0_anti}",$anti,$code);

    }
    if($p["eth1_spoof"]!=""){
        $p["eth1_spoof"]=(isset($p["eth1_spoof"])?$p["eth1_spoof"]:"");
        $p["eth1_spoof"]=$spo[$p["eth1_spoof"]];
        $code=str_replace("{eth1_spoof}",$p["eth1_spoof"],$code);
        $code=str_replace("{eth1_sp}",spcode($p["pon"],$p["onu"],$p["eth1_gem"]),$code);
        $code=str_replace("{eth1_close}","!",$code);
        $code=str_replace("{eth1_anti}",$anti,$code);
    }
    if($p["eth2_spoof"]!=""){
        $p["eth2_spoof"]=(isset($p["eth2_spoof"])?$p["eth2_spoof"]:"");
        $p["eth2_spoof"]=$spo[$p["eth2_spoof"]];
        $code=str_replace("{eth2_spoof}",$p["eth2_spoof"],$code);
        $code=str_replace("{eth2_sp}",spcode($p["pon"],$p["onu"],$p["eth2_gem"]),$code);
        $code=str_replace("{eth2_close}","!",$code);
        $code=str_replace("{eth2_anti}",$anti,$code);
    }
    if($p["eth3_spoof"]!=""){
        $p["eth3_spoof"]=(isset($p["eth3_spoof"])?$p["eth3_spoof"]:"");
        $p["eth3_spoof"]=$spo[$p["eth3_spoof"]];
        $code=str_replace("{eth3_spoof}",$p["eth3_spoof"],$code);
        $code=str_replace("{eth3_sp}",spcode($p["pon"],$p["onu"],$p["eth3_gem"]),$code);
        $code=str_replace("{eth3_close}","!",$code);
        $code=str_replace("{eth3_anti}",$anti,$code);
    }
    if($p["eth4_spoof"]!=""){
        $p["eth4_spoof"]=(isset($p["eth4_spoof"])?$p["eth4_spoof"]:"");
        $p["eth4_spoof"]=$spo[$p["eth4_spoof"]];
        $code=str_replace("{eth4_spoof}",$p["eth4_spoof"],$code);
        $code=str_replace("{eth4_sp}",spcode($p["pon"],$p["onu"],$p["eth4_gem"]),$code);
        $code=str_replace("{eth4_close}","!",$code);
        $code=str_replace("{eth4_anti}",$anti,$code);
    }
    $code=str_replace("{anti_ip_spoofing}",$code,$code_in);


    return $code;

}
function make_profiles($code_in,$p,$make=false){
    $code="line-profile {lp}";
    if($make==false){
        $code=str_replace("{profiles}",$code,$code_in);
        return $code;
    }
    if(isset($p["line_profile"])){
        $p["lp"]=str_clear($p["line_profile"],"str");
        $code=str_replace("{lp}",$p["lp"],$code);
        $code=str_replace("{profiles}",$code,$code_in);
        return $code;
    }else{
        die("Falta Parametros minimos [line-profile]");
    }
}
function make_ipv4($code_in,$p,$make=false){
    $code="";
    $code=$code."ipv4 vlan vlan-id {ipv4_vlan}\n  ipv4 vlan cos {ipv4_cos}";
    $code=$code."  ipv4 {ipv4_dhcp}\n  ipv4 static address {ipv4_ip}\n  ipv4 static default-gateway {ipv4_gw}";
    if($make==false){
        $code=str_replace("{ipv4}",$code,$code_in);
        return $code;
    }

    $p["ipv4_vlan"]=(isset($p["ipv4_vlan"])?str_clear($p["ipv4_vlan"],"vlan"):"");
    $p["ipv4_cos"]=(isset($p["ipv4_cos"])?str_clear($p["ipv4_cos"],"cos"):"");
    $p["ipv4_ip"]=(isset($p["ipv4_ip"])?str_clear($p["ipv4_ip"],"ip"):"");
    $p["ipv4_gw"]=(isset($p["ipv4_gw"])?str_clear($p["ipv4_gw"],"ip"):"");
    $p["ipv4_mode"]=(isset($p["ipv4_mode"])?$p["ipv4_mode"]:"");
    if($p["ipv4_mode"]=="1"){
        $code=str_replace("{ipv4_ip}",$p["ipv4_ip"],$code);
        $code=str_replace("{ipv4_gw}",$p["ipv4_gw"],$code);
    }elseif($p["ipv4_mode"]=="2"){
        $code=str_replace("{ipv4_dhcp}","dhcp",$code);
    }
    if($p["ipv4_vlan"]!=""){
        $code=str_replace("{ipv4_vlan}",$p["ipv4_vlan"],$code);
        $code=str_replace("{ipv4_cos}",$p["ipv4_cos"],$code);
    
    }
    

    $code=str_replace("{ipv4}",$code,$code_in);
    return $code;
}
function str_replace2($p,$t,$str){
    if($t!=""){
        return str_replace($p,$t,$str);
    }
    return $str;
}
function make_ethx($code_in,$p,$make=false){    
    $code="";
    $code=$code."{eth0_iface}\n   native vlan vlan-id {eth0_nvlan}\n   native vlan cos {eth0_ncos}\n  {eth0_close}";
    $code=$code."\n  {eth1_iface}\n   {eth1_mode}\n   native vlan vlan-id {eth1_nvlan}\n   native vlan cos {eth1_ncos}\n   mac-limit {eth1_lmac}\n  {eth1_close}";
    $code=$code."\n  {eth2_iface}\n   {eth2_mode}\n   native vlan vlan-id {eth2_nvlan}\n   native vlan cos {eth2_ncos}\n   mac-limit {eth2_lmac}\n  {eth2_close}";
    $code=$code."\n  {eth3_iface}\n   {eth3_mode}\n   native vlan vlan-id {eth3_nvlan}\n   native vlan cos {eth3_ncos}\n   mac-limit {eth3_lmac}\n  {eth3_close}";
    $code=$code."\n  {eth4_iface}\n   {eth4_mode}\n   native vlan vlan-id {eth4_nvlan}\n   native vlan cos {eth4_ncos}\n   mac-limit {eth4_lmac}\n  {eth4_close}";
    if($code_in==""){
        die("Falta parametro [codein]");
    }
    if($make==false){
        $code=str_replace("{ethx}",$code,$code_in);
        return $code;
    }


    
    $p["eth0_nvlan"]=(isset($p["eth0_nvlan"])?str_clear($p["eth0_nvlan"],"vlan"):"");
    $p["eth0_ncos"]=(isset($p["eth0_ncos"])?str_clear($p["eth0_ncos"],"cos"):"");
    $p["eth0_lmac"]=(isset($p["eth0_lmac"])?str_clear($p["eth0_lmac"],"num"):"");

    $p["eth1_nvlan"]=(isset($p["eth1_nvlan"])?str_clear($p["eth1_nvlan"],"vlan"):"");
    $p["eth1_ncos"]=(isset($p["eth1_ncos"])?str_clear($p["eth1_ncos"],"cos"):"");
    $p["eth1_lmac"]=(isset($p["eth1_lmac"])?str_clear($p["eth1_lmac"],"num"):"");

    $p["eth2_nvlan"]=(isset($p["eth2_nvlan"])?str_clear($p["eth2_nvlan"],"vlan"):"");
    $p["eth2_ncos"]=(isset($p["eth2_ncos"])?str_clear($p["eth2_ncos"],"cos"):"");
    $p["eth2_lmac"]=(isset($p["eth2_lmac"])?str_clear($p["eth2_lmac"],"num"):"");

    $p["eth3_nvlan"]=(isset($p["eth3_nvlan"])?str_clear($p["eth3_nvlan"],"vlan"):"");
    $p["eth3_ncos"]=(isset($p["eth3_ncos"])?str_clear($p["eth3_ncos"],"cos"):"");
    $p["eth3_lmac"]=(isset($p["eth3_lmac"])?str_clear($p["eth3_lmac"],"num"):"");

    $p["eth4_nvlan"]=(isset($p["eth4_nvlan"])?str_clear($p["eth4_nvlan"],"vlan"):"");
    $p["eth4_ncos"]=(isset($p["eth4_ncos"])?str_clear($p["eth4_ncos"],"cos"):"");
    $p["eth4_lmac"]=(isset($p["eth4_lmac"])?str_clear($p["eth4_lmac"],"num"):"");

    $close="!";
    $noshutdown="no shutdown\n";
    $nspeed=$noshutdown."   no negotiation\n   speed ";
    for ($i = 0; $i <=4; $i++) {
        $iface="eth".$i."_";
        $eth=($i==0?"veip 1":"ethernet ".$i);
        $modex="";
        if(isset($p[$iface."mode"])){    
            $mode=(isset($p[$iface."mode"])?$p[$iface."mode"]:"");
            if($mode!=""){
                if($mode=="1"){
                    $modex=$noshutdown."   negotiation";
                }elseif($mode=="2"){
                    $modex=$nspeed."1000 duplex full";
                }elseif($mode=="3"){
                    $modex=$nspeed."1000 duplex half";
                }elseif($mode=="4"){
                    $modex=$nspeed."100 duplex full";
                }elseif($mode=="5"){
                    $modex=$nspeed."100 duplex half";
                }elseif($mode=="6"){
                    $modex=$nspeed."10 duplex full";
                }elseif($mode=="7"){
                    $modex=$nspeed."10 duplex half";
                }elseif($mode=="0"){
                    $modex="shutdown";
                }
                $code=str_replace2("{{$iface}iface}",$eth,$code);
                $code=str_replace2("{{$iface}close}",$close,$code);
                $code=str_replace2("{{$iface}nvlan}",$p["{$iface}nvlan"],$code);
                $code=str_replace2("{{$iface}ncos}",$p["{$iface}ncos"],$code);
                $code=str_replace2("{{$iface}lmac}",$p["{$iface}lmac"],$code);
                $code=str_replace2("{{$iface}mode}",$modex,$code);
                //echo $iface."---".$mode."---".$modex."\n";
               
                
            }
        }
    }
    $code=str_replace("{ethx}",$code,$code_in);
    return $code;
}
function make_code_clear($code){
    $code2="";
    $lines=preg_split('#\n#',$code);
    $qlines=sizeof($lines);
    for ($i = 0; $i <=$qlines-1; $i++) {
        $line=$lines[$i];
        if(strpos($line,'{')===false){
            $code2=$code2.$line."\n";
        }
    }
    return $code2;
}
function make_sp($code_in,$p,$make=false){
    $code="";
    $code=$code."service-port {ipv4_sp} gpon {pon} onu {onu} gem {ipv4_gem} match vlan vlan-id {ipv4_vlan} action vlan {ipv4_action} vlan-id {ipv4_outvlan} ; top ;\n";
    $code=$code."service-port {eth0_sp} gpon {pon} onu {onu} gem {eth0_gem} match vlan vlan-id {eth0_nvlan} action vlan {eth0_action} vlan-id {eth0_outvlan} ; top ;\n";
    $code=$code."service-port {eth1_sp} gpon {pon} onu {onu} gem {eth1_gem} match vlan vlan-id {eth1_nvlan} action vlan {eth1_action} vlan-id {eth1_outvlan} ; top ;\n";
    $code=$code."service-port {eth2_sp} gpon {pon} onu {onu} gem {eth2_gem} match vlan vlan-id {eth2_nvlan} action vlan {eth2_action} vlan-id {eth2_outvlan} ; top ;\n";
    $code=$code."service-port {eth3_sp} gpon {pon} onu {onu} gem {eth3_gem} match vlan vlan-id {eth3_nvlan} action vlan {eth3_action} vlan-id {eth3_outvlan} ; top ;\n";
    $code=$code."service-port {eth4_sp} gpon {pon} onu {onu} gem {eth4_gem} match vlan vlan-id {eth4_nvlan} action vlan {eth4_action} vlan-id {eth4_outvlan} ; top ;\n";
    if($make==false){
        $code=str_replace("{service_port}",$code,$code_in);
        return $code;
    }
    $p["ipv4_vlan"]=(isset($p["ipv4_vlan"])?str_clear($p["ipv4_vlan"],"vlan"):"");
    $p["ipv4_cos"]=(isset($p["ipv4_cos"])?str_clear($p["ipv4_cos"],"cos"):"");
    $p["ipv4_ip"]=(isset($p["ipv4_ip"])?str_clear($p["ipv4_ip"],"ip"):"");
    $p["ipv4_gw"]=(isset($p["ipv4_gw"])?str_clear($p["ipv4_gw"],"ip"):"");
    $p["ipv4_mode"]=(isset($p["ipv4_mode"])?$p["ipv4_mode"]:"");

    $p["ipv4_sp"]=(isset($p["ipv4_sp"])?$p["ipv4_sp"]:"");
    $p["ipv4_gem"]=(isset($p["ipv4_gem"])?$p["ipv4_gem"]:"");
    $p["ipv4_vlan"]=(isset($p["ipv4_vlan"])?$p["ipv4_lan"]:"");
    $p["ipv4_action"]=(isset($p["ipv4_action"])?$p["ipv4_action"]:"");
    $p["ipv4_outvlan"]=(isset($p["ipv4_outvlan"])?$p["ipv4_outvlan"]:"");
    $p["ipv4_innervlan"]=(isset($p["ipv4_innervlan"])?$p["ipv4_innervlan"]:"");

    $p["eth0_sp"]=(isset($p["eth0_sp"])?$p["eth0_sp"]:"");
    $p["eth0_gem"]=(isset($p["eth0_gem"])?$p["eth0_gem"]:""); 
    $p["eth0_nvlan"]=(isset($p["eth0_nvlan"])?$p["eth0_nvlan"]:"");
    $p["eth0_action"]=(isset($p["eth0_action"])?$p["eth0_action"]:"");
    $p["eth0_outvlan"]=(isset($p["eth0_outvlan"])?$p["eth0_outvlan"]:"");
    $p["eth0_innervlan"]=(isset($p["eth0_innervlan"])?$p["eth0_innervlan"]:"");

    $p["eth1_sp"]=(isset($p["eth1_sp"])?$p["eth1_sp"]:"");
    $p["eth1_gem"]=(isset($p["eth1_gem"])?$p["eth1_gem"]:"");
    $p["eth1_nvlan"]=(isset($p["eth1_nvlan"])?$p["eth1_nvlan"]:"");
    $p["eth1_action"]=(isset($p["eth1_action"])?$p["eth1_action"]:"");
    $p["eth1_outvlan"]=(isset($p["eth1_outvlan"])?$p["eth1_outvlan"]:"");
    $p["eth1_innervlan"]=(isset($p["eth1_innervlan"])?$p["eth1_innervlan"]:"");

    $p["eth2_sp"]=(isset($p["eth2_sp"])?$p["eth2_sp"]:"");
    $p["eth2_gem"]=(isset($p["eth2_gem"])?$p["eth2_gem"]:"");
    $p["eth2_nvlan"]=(isset($p["eth2_nvlan"])?$p["eth2_nvlan"]:"");
    $p["eth2_action"]=(isset($p["eth2_action"])?$p["eth2_action"]:"");
    $p["eth2_outvlan"]=(isset($p["eth2_outvlan"])?$p["eth2_outvlan"]:"");
    $p["eth2_innervlan"]=(isset($p["eth2_innervlan"])?$p["eth2_innervlan"]:"");    

    $p["eth3_sp"]=(isset($p["eth3_sp"])?$p["eth3_sp"]:"");
    $p["eth3_gem"]=(isset($p["eth3_gem"])?$p["eth3_gem"]:"");
    $p["eth3_nvlan"]=(isset($p["eth3_nvlan"])?$p["eth3_nvlan"]:"");
    $p["eth3_action"]=(isset($p["eth3_action"])?$p["eth3_action"]:"");
    $p["eth3_outvlan"]=(isset($p["eth3_outvlan"])?$p["eth3_outvlan"]:"");
    $p["eth3_innervlan"]=(isset($p["eth3_innervlan"])?$p["eth3_innervlan"]:"");

    $p["eth4_sp"]=(isset($p["eth4_sp"])?$p["eth4_sp"]:"");
    $p["eth4_gem"]=(isset($p["eth4_gem"])?$p["eth4_gem"]:"");
    $p["eth4_nvlan"]=(isset($p["eth4_nvlan"])?$p["eth4_nvlan"]:"");
    $p["eth4_action"]=(isset($p["eth4_action"])?$p["eth4_action"]:"");
    $p["eth4_outvlan"]=(isset($p["eth4_outvlan"])?$p["eth4_outvlan"]:"");   
    $p["eth4_innervlan"]=(isset($p["eth4_innervlan"])?$p["eth4_innervlan"]:"");

    
    $p["pon"]=str_clear($p["pon"],"pon");
    $p["onu"]=str_clear($p["onu"],"onu");
    
    $code=str_replace("{pon}",$p["pon"],$code);
    $code=str_replace("{onu}",$p["onu"],$code);

    if($p["ipv4_sp"]!="" and $p["ipv4_gem"]!="" and $p["ipv4_action"]!="" and $p["ipv4_outvlan"]!=""){
        $p["ipv4_sp"]=spcode($p["pon"],$p["onu"],$p["ipv4_gem"]);
        $code=str_replace("{ipv4_sp}",$p["ipv4_sp"],$code);
        $code=str_replace("{ipv4_gem}",$p["ipv4_gem"],$code);
        $code=str_replace("{ipv4_vlan}",$p["ipv4_vlan"],$code);
        $code=str_replace("{ipv4_action}",$p["ipv4_action"],$code);
        $code=str_replace("{ipv4_outvlan}",$p["ipv4_outvlan"],$code);
        $code=str_replace("{ipv4_innervlan}",$p["ipv4_innervlan"],$code);    
    }
    if($p["eth0_sp"]!="" and $p["eth0_gem"]!="" and $p["eth0_action"]!="" and $p["eth0_outvlan"]!=""){
        $p["eth0_sp"]=spcode($p["pon"],$p["onu"],$p["eth0_gem"]);
        $code=str_replace("{eth0_sp}",$p["eth0_sp"],$code);
        $code=str_replace("{eth0_gem}",$p["eth0_gem"],$code);
        $code=str_replace("{eth0_nvlan}",$p["eth0_nvlan"],$code);
        $code=str_replace("{eth0_action}",$p["eth0_action"],$code);
        $code=str_replace("{eth0_outvlan}",$p["eth0_outvlan"],$code);
        $code=str_replace("{eth0_innervlan}",$p["eth0_innervlan"],$code);    
    }
    if($p["eth1_sp"]!="" and $p["eth1_gem"]!="" and $p["eth1_action"]!="" and $p["eth1_outvlan"]!=""){
        $p["eth1_sp"]=spcode($p["pon"],$p["onu"],$p["eth1_gem"]);
        $code=str_replace("{eth1_sp}",$p["eth1_sp"],$code);
        $code=str_replace("{eth1_gem}",$p["eth1_gem"],$code);
        $code=str_replace("{eth1_nvlan}",$p["eth1_nvlan"],$code);
        $code=str_replace("{eth1_action}",$p["eth1_action"],$code);
        $code=str_replace("{eth1_outvlan}",$p["eth1_outvlan"],$code);
        $code=str_replace("{eth1_innervlan}",$p["eth1_innervlan"],$code);
    }
    if($p["eth2_sp"]!="" and $p["eth2_gem"]!="" and $p["eth2_action"]!="" and $p["eth2_outvlan"]!=""){
        $p["eth2_sp"]=spcode($p["pon"],$p["onu"],$p["eth2_gem"]);
        $code=str_replace("{eth2_sp}",$p["eth2_sp"],$code);
        $code=str_replace("{eth2_gem}",$p["eth2_gem"],$code);
        $code=str_replace("{eth2_nvlan}",$p["eth2_nvlan"],$code);
        $code=str_replace("{eth2_action}",$p["eth2_action"],$code);
        $code=str_replace("{eth2_outvlan}",$p["eth2_outvlan"],$code);
        $code=str_replace("{eth2_innervlan}",$p["eth2_innervlan"],$code);    
    }
    if($p["eth3_sp"]!="" and $p["eth3_gem"]!="" and $p["eth3_action"]!="" and $p["eth3_outvlan"]!=""){
        $p["eth3_sp"]=spcode($p["pon"],$p["onu"],$p["eth3_gem"]);
        $code=str_replace("{eth0_sp}",$p["eth3_sp"],$code);
        $code=str_replace("{eth3_gem}",$p["eth3_gem"],$code);
        $code=str_replace("{eth3_nvlan}",$p["eth3_nvlan"],$code);
        $code=str_replace("{eth3_action}",$p["eth3_action"],$code);
        $code=str_replace("{eth3_outvlan}",$p["eth3_outvlan"],$code);
        $code=str_replace("{eth3_innervlan}",$p["eth3_innervlan"],$code);    
    }
    if($p["eth4_sp"]!="" and $p["eth4_gem"]!="" and $p["eth4_action"]!="" and $p["eth4_outvlan"]!=""){
        $p["eth4_sp"]=spcode($p["pon"],$p["onu"],$p["eth4_gem"]);
        $code=str_replace("{eth4_sp}",$p["eth4_sp"],$code);
        $code=str_replace("{eth4_gem}",$p["eth4_gem"],$code);
        $code=str_replace("{eth4_nvlan}",$p["eth4_nvlan"],$code);
        $code=str_replace("{eth4_action}",$p["eth4_action"],$code);
        $code=str_replace("{eth4_outvlan}",$p["eth4_outvlan"],$code);
        $code=str_replace("{eth4_innervlan}",$p["eth4_innervlan"],$code);    
    }
    
    $code=str_replace("{service_port}",$code,$code_in);
    return $code;
}
function make_spcode($code_in,$p,$make=false){
    $act["R"]="replace";
    $act["A"]="add";
    $code="";
    $code=$code."service-port {ipv4_sp}\n gpon {pon} onu {onu} gem {ipv4_gem} match vlan vlan-id {ipv4_vlan} action vlan {ipv4_action} vlan-id {ipv4_outvlan}\n{ipv4_close}";
    $code=$code."\nservice-port {eth0_sp}\n gpon {pon} onu {onu} gem {eth0_gem} match vlan vlan-id {eth0_nvlan} action vlan {eth0_action} vlan-id {eth0_outvlan}\n{eth0_close}";
    $code=$code."\nservice-port {eth1_sp}\n gpon {pon} onu {onu} gem {eth1_gem} match vlan vlan-id {eth1_nvlan} action vlan {eth1_action} vlan-id {eth1_outvlan}\n{eth1_close}";
    $code=$code."\nservice-port {eth2_sp}\n gpon {pon} onu {onu} gem {eth2_gem} match vlan vlan-id {eth2_nvlan} action vlan {eth2_action} vlan-id {eth2_outvlan}\n{eth2_close}";
    $code=$code."\nservice-port {eth3_sp}\n gpon {pon} onu {onu} gem {eth3_gem} match vlan vlan-id {eth3_nvlan} action vlan {eth3_action} vlan-id {eth3_outvlan}\n{eth3_close}";
    $code=$code."\nservice-port {eth4_sp}\n gpon {pon} onu {onu} gem {eth4_gem} match vlan vlan-id {eth4_nvlan} action vlan {eth4_action} vlan-id {eth4_outvlan}\n{eth4_close}";
    if($make==false){
        $code=str_replace("{service_port}",$code,$code_in);
        return $code;
    }
    $p["ipv4_vlan"]=(isset($p["ipv4_vlan"])?str_clear($p["ipv4_vlan"],"vlan"):"");
    $p["ipv4_cos"]=(isset($p["ipv4_cos"])?str_clear($p["ipv4_cos"],"cos"):"");
    $p["ipv4_ip"]=(isset($p["ipv4_ip"])?str_clear($p["ipv4_ip"],"ip"):"");
    $p["ipv4_gw"]=(isset($p["ipv4_gw"])?str_clear($p["ipv4_gw"],"ip"):"");
    $p["ipv4_mode"]=(isset($p["ipv4_mode"])?$p["ipv4_mode"]:"");

    $p["ipv4_sp"]=(isset($p["ipv4_sp"])?$p["ipv4_sp"]:"");
    $p["ipv4_gem"]=(isset($p["ipv4_gem"])?$p["ipv4_gem"]:"");
    $p["ipv4_vlan"]=(isset($p["ipv4_vlan"])?$p["ipv4_lan"]:"");
    $p["ipv4_action"]=(isset($p["ipv4_action"])?$p["ipv4_action"]:"");
    $p["ipv4_outvlan"]=(isset($p["ipv4_outvlan"])?$p["ipv4_outvlan"]:"");
    $p["ipv4_innervlan"]=(isset($p["ipv4_innervlan"])?$p["ipv4_innervlan"]:"");

    $p["eth0_sp"]=(isset($p["eth0_sp"])?$p["eth0_sp"]:"");
    $p["eth0_gem"]=(isset($p["eth0_gem"])?$p["eth0_gem"]:""); 
    $p["eth0_nvlan"]=(isset($p["eth0_nvlan"])?$p["eth0_nvlan"]:"");
    $p["eth0_action"]=(isset($p["eth0_action"])?$p["eth0_action"]:"");
    $p["eth0_outvlan"]=(isset($p["eth0_outvlan"])?$p["eth0_outvlan"]:"");
    $p["eth0_innervlan"]=(isset($p["eth0_innervlan"])?$p["eth0_innervlan"]:"");

    $p["eth1_sp"]=(isset($p["eth1_sp"])?$p["eth1_sp"]:"");
    $p["eth1_gem"]=(isset($p["eth1_gem"])?$p["eth1_gem"]:"");
    $p["eth1_nvlan"]=(isset($p["eth1_nvlan"])?$p["eth1_nvlan"]:"");
    $p["eth1_action"]=(isset($p["eth1_action"])?$p["eth1_action"]:"");
    $p["eth1_outvlan"]=(isset($p["eth1_outvlan"])?$p["eth1_outvlan"]:"");
    $p["eth1_innervlan"]=(isset($p["eth1_innervlan"])?$p["eth1_innervlan"]:"");

    $p["eth2_sp"]=(isset($p["eth2_sp"])?$p["eth2_sp"]:"");
    $p["eth2_gem"]=(isset($p["eth2_gem"])?$p["eth2_gem"]:"");
    $p["eth2_nvlan"]=(isset($p["eth2_nvlan"])?$p["eth2_nvlan"]:"");
    $p["eth2_action"]=(isset($p["eth2_action"])?$p["eth2_action"]:"");
    $p["eth2_outvlan"]=(isset($p["eth2_outvlan"])?$p["eth2_outvlan"]:"");
    $p["eth2_innervlan"]=(isset($p["eth2_innervlan"])?$p["eth2_innervlan"]:"");    

    $p["eth3_sp"]=(isset($p["eth3_sp"])?$p["eth3_sp"]:"");
    $p["eth3_gem"]=(isset($p["eth3_gem"])?$p["eth3_gem"]:"");
    $p["eth3_nvlan"]=(isset($p["eth3_nvlan"])?$p["eth3_nvlan"]:"");
    $p["eth3_action"]=(isset($p["eth3_action"])?$p["eth3_action"]:"");
    $p["eth3_outvlan"]=(isset($p["eth3_outvlan"])?$p["eth3_outvlan"]:"");
    $p["eth3_innervlan"]=(isset($p["eth3_innervlan"])?$p["eth3_innervlan"]:"");

    $p["eth4_sp"]=(isset($p["eth4_sp"])?$p["eth4_sp"]:"");
    $p["eth4_gem"]=(isset($p["eth4_gem"])?$p["eth4_gem"]:"");
    $p["eth4_nvlan"]=(isset($p["eth4_nvlan"])?$p["eth4_nvlan"]:"");
    $p["eth4_action"]=(isset($p["eth4_action"])?$p["eth4_action"]:"");
    $p["eth4_outvlan"]=(isset($p["eth4_outvlan"])?$p["eth4_outvlan"]:"");   
    $p["eth4_innervlan"]=(isset($p["eth4_innervlan"])?$p["eth4_innervlan"]:"");

    
    $p["pon"]=str_clear($p["pon"],"pon");
    $p["onu"]=str_clear($p["onu"],"onu");
    
    $code=str_replace("{pon}",$p["pon"],$code);
    $code=str_replace("{onu}",$p["onu"],$code);

    if($p["ipv4_gem"]!="" and $p["ipv4_action"]!="" and $p["ipv4_outvlan"]!=""){
        $p["ipv4_sp"]=spcode($p["pon"],$p["onu"],$p["ipv4_gem"]);
        $code=str_replace("{ipv4_sp}",$p["ipv4_sp"],$code);
        $code=str_replace("{ipv4_gem}",$p["ipv4_gem"],$code);
        $code=str_replace("{ipv4_vlan}",$p["ipv4_vlan"],$code);
        $code=str_replace("{ipv4_action}",$act[$p["ipv4_action"]],$code);
        $code=str_replace("{ipv4_outvlan}",$p["ipv4_outvlan"],$code);
        $code=str_replace("{ipv4_innervlan}",$p["ipv4_innervlan"],$code);
        $code=str_replace("{ipv4_close}","!",$code);

    }
    if($p["eth0_gem"]!="" and $p["eth0_action"]!="" and $p["eth0_outvlan"]!=""){
        $p["eth0_sp"]=spcode($p["pon"],$p["onu"],$p["eth0_gem"]);
        $code=str_replace("{eth0_sp}",$p["eth0_sp"],$code);
        $code=str_replace("{eth0_gem}",$p["eth0_gem"],$code);
        $code=str_replace("{eth0_nvlan}",$p["eth0_nvlan"],$code);
        $code=str_replace("{eth0_action}",$act[$p["eth0_action"]],$code);
        $code=str_replace("{eth0_outvlan}",$p["eth0_outvlan"],$code);
        $code=str_replace("{eth0_innervlan}",$p["eth0_innervlan"],$code);    
        $code=str_replace("{eth0_close}","!",$code);
    }
    if($p["eth1_gem"]!="" and $p["eth1_action"]!="" and $p["eth1_outvlan"]!=""){
        $p["eth1_sp"]=spcode($p["pon"],$p["onu"],$p["eth1_gem"]);
        $code=str_replace("{eth1_sp}",$p["eth1_sp"],$code);
        $code=str_replace("{eth1_gem}",$p["eth1_gem"],$code);
        $code=str_replace("{eth1_nvlan}",$p["eth1_nvlan"],$code);
        $code=str_replace("{eth1_action}",$act[$p["eth1_action"]],$code);
        $code=str_replace("{eth1_outvlan}",$p["eth1_outvlan"],$code);
        $code=str_replace("{eth1_innervlan}",$p["eth1_innervlan"],$code);
        $code=str_replace("{eth1_close}","!",$code);
    }
    if($p["eth2_gem"]!="" and $p["eth2_action"]!="" and $p["eth2_outvlan"]!=""){
        $p["eth2_sp"]=spcode($p["pon"],$p["onu"],$p["eth2_gem"]);
        $code=str_replace("{eth2_sp}",$p["eth2_sp"],$code);
        $code=str_replace("{eth2_gem}",$p["eth2_gem"],$code);
        $code=str_replace("{eth2_nvlan}",$p["eth2_nvlan"],$code);
        $code=str_replace("{eth2_action}",$act[$p["eth2_action"]],$code);
        $code=str_replace("{eth2_outvlan}",$p["eth2_outvlan"],$code);
        $code=str_replace("{eth2_innervlan}",$p["eth2_innervlan"],$code);  
        $code=str_replace("{eth2_close}","!",$code);  
    }
    if($p["eth3_gem"]!="" and $p["eth3_action"]!="" and $p["eth3_outvlan"]!=""){
        $p["eth3_sp"]=spcode($p["pon"],$p["onu"],$p["eth3_gem"]);
        $code=str_replace("{eth0_sp}",$p["eth3_sp"],$code);
        $code=str_replace("{eth3_gem}",$p["eth3_gem"],$code);
        $code=str_replace("{eth3_nvlan}",$p["eth3_nvlan"],$code);
        $code=str_replace("{eth3_action}",$act[$p["eth3_action"]],$code);
        $code=str_replace("{eth3_outvlan}",$p["eth3_outvlan"],$code);
        $code=str_replace("{eth3_innervlan}",$p["eth3_innervlan"],$code);    
        $code=str_replace("{eth3_close}","!",$code);
    }
    if($p["eth4_gem"]!="" and $p["eth4_action"]!="" and $p["eth4_outvlan"]!=""){
        $p["eth4_sp"]=spcode($p["pon"],$p["onu"],$p["eth4_gem"]);
        $code=str_replace("{eth4_sp}",$p["eth4_sp"],$code);
        $code=str_replace("{eth4_gem}",$p["eth4_gem"],$code);
        $code=str_replace("{eth4_nvlan}",$p["eth4_nvlan"],$code);
        $code=str_replace("{eth4_action}",$act[$p["eth4_action"]],$code);
        $code=str_replace("{eth4_outvlan}",$p["eth4_outvlan"],$code);
        $code=str_replace("{eth4_innervlan}",$p["eth4_innervlan"],$code);    
        $code=str_replace("{eth4_close}","!",$code);
    }
    
    $code=str_replace("{service_port}",$code,$code_in);
    return $code;
}
function make_complete_onu($p,$make=false){
    $code=make_onu("",$p,$make);
    $code=make_profiles($code,$p,$make);
    $code=make_ipv4($code,$p,$make);
    $code=make_ethx($code,$p,$make);
    $code=make_spcode($code,$p,$make);
    $code=make_anti_ip_spoofing($code,$p,$make);

    if($make!==false){
        $code=make_code_clear($code);    
    }
    return $code;
}
function onu_delete($p,$make=false){
    $code="";
    $code=$code."interface gpon {pon}\n no onu {onu}\n!";

    $code=$code."\nno service-port {ipv4_sp} ; top ;";
    $code=$code."\nno service-port {eth0_sp} ; top ;";
    $code=$code."\nno service-port {eth1_sp} ; top ;";
    $code=$code."\nno service-port {eth2_sp} ; top ;";
    $code=$code."\nno service-port {eth3_sp} ; top ;";
    $code=$code."\nno service-port {eth4_sp} ; top ;";

    $code=$code."\nanti-ip-spoofing ; no interface service-port-{ipv4_sp} ; top ;";
    $code=$code."\nanti-ip-spoofing ; no interface service-port-{eth0_sp} ; top ;";
    $code=$code."\nanti-ip-spoofing ; no interface service-port-{eth1_sp} ; top ;";
    $code=$code."\nanti-ip-spoofing ; no interface service-port-{eth2_sp} ; top ;";
    $code=$code."\nanti-ip-spoofing ; no interface service-port-{eth3_sp} ; top ;";
    $code=$code."\nanti-ip-spoofing ; no interface service-port-{eth4_sp} ; top ;";

    if($make==false){
        return $code;
    }
    if(isset($p["pon"]) and isset($p["onu"])){

        $p["pon"]=(isset($p["pon"])?str_clear($p["pon"],"pon"):"");
        $p["onu"]=(isset($p["onu"])?str_clear($p["onu"],"onu"):"");
        

        $p["ipv4_sp"]=(isset($p["ipv4_sp"])?str_clear($p["ipv4_sp"],"num"):"");
        $p["eth0_sp"]=(isset($p["eth0_sp"])?str_clear($p["eth0_sp"],"num"):"");
        $p["eth1_sp"]=(isset($p["eth1_sp"])?str_clear($p["eth1_sp"],"num"):"");
        $p["eth2_sp"]=(isset($p["eth2_sp"])?str_clear($p["eth2_sp"],"num"):"");
        $p["eth3_sp"]=(isset($p["eth3_sp"])?str_clear($p["eth3_sp"],"num"):"");
        $p["eth4_sp"]=(isset($p["eth4_sp"])?str_clear($p["eth4_sp"],"num"):"");

            
        $code=str_replace("{pon}",$p["pon"],$code);
        $code=str_replace("{onu}",$p["onu"],$code);

        if($p["ipv4_sp"]!=""){$code=str_replace("{ipv4_sp}",$p["ipv4_sp"],$code);}
        if($p["eth0_sp"]!=""){$code=str_replace("{eth0_sp}",$p["eth0_sp"],$code);}
        if($p["eth1_sp"]!=""){$code=str_replace("{eth1_sp}",$p["eth1_sp"],$code);}
        if($p["eth2_sp"]!=""){$code=str_replace("{eth2_sp}",$p["eth2_sp"],$code);}
        if($p["eth3_sp"]!=""){$code=str_replace("{eth3_sp}",$p["eth3_sp"],$code);}
        if($p["eth4_sp"]!=""){$code=str_replace("{eth4_sp}",$p["eth4_sp"],$code);}

        $code=make_code_clear($code);
        return $code;
    }else{
        die("Falta Parametros minimos, pon,onu,serial,lp");
    }
}
function onu_update($p,$make=false){
    $code_in="interface gpon ".$p["pon"]."\n no onu ".$p["onu"]."\n!\n";
    $code=make_onu($code_in,$p,$make);
    $code=make_profiles($code,$p,$make);
    $code=make_ipv4($code,$p,$make);
    $code=make_ethx($code,$p,$make);
    if($make!==false){
        $code=make_code_clear($code);    
    }
    return $code;
}
function code2html($code){
    $html=str_replace("\n","<BR>",$code);
    $html="<pre>".$html."</pre>";
    return $html;
}
function code_cut($code,$tag1,$tag2,$is_true="",$is_false=""){
    $code=preg_replace("#\r#","",$code);
    
    $ret=$is_false;
    //$t=preg_match_all('#'.$tag1.'(.+?)'.$tag2.'.+0#is', $code, $array_saida);
    $analize='#'.$tag1.'(.+?)'.$tag2.'#s';
    //die($analize);
    $t=preg_match_all($analize, $code, $array_saida);
    if($t>=1){
        $ret=$array_saida[1][0];
  /*     
        if(strpos($ret,$tag2)!==false){
            $ret=$is_true;
        }
        */
        if($is_true!=""){
            $ret=$is_true;
        }
    }
    return trim($ret);
}
//echo spcode('1/1/16',"10","1");
?>