<?php
    require_once '/home/dom/www/lib/php/meekrodb-2.3.1/db.class.php';
    include_once "controller.php";
    DB::$host = '127.0.0.1'; 
    DB::$port = '3306';
    DB::$encoding = 'utf8'; // defaults to latin1 if omitted
    DB::$user = 'root';
    DB::$password = 'z25804565';
    DB::$dbName = 'olt_controller';



    define ("C_COMPLETE",'Commit complete');
    define ("V_COMPLETE",'Validation complete');
    define ("TBL_OLT","_olts");
    define ("TBL_ONU","_onus");
    define ("TBL_SP","_service_port");
    define ("TBL_ONU_TEMPLATES","_onus_templates");
    define ("TBL_DISCOVERY","_discovery");
    
    define ("ERR_00","Commit");
    define ("ERR_01","Check");
    
    define ("ERR_03","-err 03. Sem Resultados.");
    define ("ERR_04","-err 04. OLT nao encontrada no endereco especificado.");
    define ("ERR_05","-err 05. Funcao mal formada.");
    define ("ERR_06","-err 06. OLT nao existe.");
    define ("ERR_07","-err 07. Onu nao existe na OLT.");
    
    define ("ERR_40","-err 40. Não existe mais posicoes no ramo.");
    define ("ERR_60",'-err 60. Template nao existe.');


/*
    $results = DB::query("SELECT * from _onus");
    foreach ($results as $row) {
      echo "Name: " . $row['onu_name'] . "\n";
      echo "GPON: ".$row["pon_id"]."\n";
    }
*/
function dm_cmd2($a){
    return "test do php2 mmmmmmmx";
}

function cmd($host,$port,$user,$pass,$cmd){
   $cmd=str_replace('"','\"',$cmd);
   $ret="-err 10. Erro nos Parametros de conexao com o SSH.\n";
   if($host!="" and $port!="" and $user!="" and $pass!="" and $cmd!=""){
      $cmd='sshpass -p '.$pass.' ssh  -o StrictHostKeyChecking=no -p '.$port." ".$user."@".$host.' "'.$cmd.'" 2> /dev/null';
      $ret=shell_exec($cmd);
   }else{
      die($ret);
   }
   return $ret;
}
function dm_connect($host,$port,$user,$pass){
    $cmd='show inventory chassis 1 slot 1 brief | include "1/" | nomore ;';
    $ret="";
    $ret=cmd($host,$port,$user,$pass,$cmd);
    if(strpos($ret,"-err")!==true){
        if(strpos($ret,"/")!==false){
            $ret=trim(preg_replace('/( )+/', " ",$ret));
            $lines=preg_split("# #",$ret);
            $ret=$lines[3];
        }else{
            $ret=ERR_04;
        }
    }
    return $ret;
}




function dm_cmd($olt_id,$cmd){
    $row = DB::queryFirstRow("SELECT * FROM _olts WHERE olt_id=%s", $olt_id);
    /*
    $cmd='sshpass -p '.$row["olt_pass"].' ssh  -o StrictHostKeyChecking=no -p '.$row["port"]." ".$row["olt_user"]."@".$row["ip"].' "'.$cmd.'"';
    $ret=shell_exec($cmd);
    */
    $ret="-err 20. Erro nos parametros retornados pelo Banco.\n";
    if(isset($row)){
      $ret=cmd($row["ip"],$row["port"],$row["olt_user"],$row["olt_pass"],$cmd);
    }else{
       die($ret);
    }
    return $ret;
}

function str_cut($string,$inicio,$fim){
    $result="";
    $tam=strlen($string);
     if($inicio==""){
        $p2=strpos($string,$fim);
        if($p2!==false){
           $result=substr($string,0,$p2);
        }
     }elseif($fim==""){
        $p1=strpos($string,$inicio);
        if($p1!==false){
           $pt=$p1+strlen($inicio);
           $result=substr($string,$pt,strlen($string));
        }
        
     }else{
        $p1=strpos($string,$inicio);
        if($p1!==false){
           $pt=$p1+strlen($inicio);
           $p2=strpos($string,$fim,$pt);
           if($p2!==false){
              $result= substr($string,$pt,$p2-$pt);
           }else{
              $result=substr($string,$pt,$tam);
           }
        }
     }
     return trim($result);
  }

  function str_clear($str,$type){
    $ret="false";
    $str=trim($str);
    if($type=="str"){
        $str=preg_replace("#[^0-9|A-Z|a-z|\ |\_|\-]#", "", $str);
        $str=preg_replace("# #", "_", $str);
        $ret=substr($str, 0, 128);
    }
    if($type=="name"){
       
       $str=preg_replace("#[^0-9|A-Z|a-z|\ |\_|\-]#", "", $str);
       $str=preg_replace("# #", "_", $str);
       $ret=substr($str, 0, 48);
   }
    if($type=="serial"){
        
        $str=strtoupper($str);
        $str=preg_replace("#[^0-9|A-Z]#", "", $str);
        $ret=$str;
    }
    if($type=="ip"){
        $str=preg_replace("#[^0-9\/\.]#", "", $str);
        $ret=$str;
    }
    if($type=="vlan"){
        if($str!=""){
            $str=preg_replace("#[^0-9]|any#", "", $str);
        }else{
            $str="any";
        }
        $ret=$str;
    }
    if($type=="cos"){
        if($str!=""){
            $str=preg_replace("#[^0-7]|any#", "", $str);
        }else{
            $str="any";
        }
        if($str>=0 and $str<=7){
            $ret=$str;
        }
    }
    if($type=="tcont"){
        $str=preg_replace("#[^1-6]#", "", $str);
        if($str>=1 and $str<=6){
            $ret=$str;
        }
    }
    if($type=="gem"){
        $str=preg_replace("#[^1-6]#", "", $str);
        $ret=$str;
    }
    if($type=="priority"){
        $str=preg_replace("#[^0-7]#", "", $str);
        $ret=$str;
    }
    if($type=="onu"){
        $str=preg_replace("#[^0-9]#", "", $str);
        $ret=$str;
    }
    if($type=="pon"){
        $str=preg_replace("#[^0-9|\/]#", "", $str);
        $ret=$str;
    }
    if($type=="num"){
        $str=preg_replace("#[^0-9]#", "", $str);
        $ret=$str;
    }
    return $ret;
}


?>