<?php


    include_once "lib.php";


function dm_sync_discovery($olt_id){
        $last_update=date('Y-m-d H:i:s');
        $ret=ERR_05;
        if($olt_id!=""){
            $cmd='show interface gpon discovered-onus | nomore | include "     " ;';
            $r=dm_cmd($olt_id,$cmd);
            $lines=preg_split('#\n#',$r);
            $qlines=sizeof($lines);
            $arr1=array();
            DB::query('DELETE FROM '.TBL_DISCOVERY.' WHERE olt_id="'.$olt_id.'"');
            for ($i = 0; $i <=$qlines-1; $i++) {
                $b=trim(preg_replace('/( )+/', " ",$lines[$i]));
                if(strpos($b,'/')!==false){
                    $line=preg_split("# #",$b);
                    $pon_id=$line[0];
                    $serial=$line[1];
                    DB::insert(TBL_DISCOVERY, [
                        'olt_id'=>$olt_id,
                        'onu_serial'=>$serial,
                        'pon_id' => $pon_id,
                        'last_update'=>$last_update,
                    ]);
                }
            }
            
        }
    }
function dm_sync_gpon($olt_id,$pon_id){
        $ret=ERR_05;
        $last_update=date('Y-m-d H:i:s');
        if($olt_id!=""){
            $ret=ERR_06;
            $query='SELECT * FROM '.TBL_OLT.' where olt_id="'.$olt_id.'" limit 1;';
            $row = DB::queryFirstRow($query);
            if(isset($row)){
                $olt_id=$row["olt_id"];
                if ($olt_id!=""){
                    if($pon_id!=""){
                        DB::query('DELETE FROM '.TBL_ONU.' WHERE olt_id="'.$olt_id.'" and pon_id="'.$pon_id.'"');
                    }else{
                        DB::query('DELETE FROM '.TBL_ONU.' WHERE olt_id="'.$olt_id.'"');
                    }
                    DB::query('DELETE FROM '.TBL_SP.' WHERE olt_id="'.$olt_id.'"');
                }
                $cmd1='show running-config service-port | tab | csv | select gpon | nomore ;';
                $cmd2='show interface gpon '.$pon_id.' onu | nomore ; ';
                $r=dm_cmd($olt_id,$cmd1.$cmd2);
                
                $lines=preg_split('#\n#',$r);
                $qlines=sizeof($lines);
                $arr1=array();
                for ($i = 0; $i <=$qlines-1; $i++) {
                    $b=trim(preg_replace('/( )+/', " ",$lines[$i]));
                    if(strpos($b,'/')!==false){
                        if(strpos($b,',')!==false){
                            $line=preg_split('#,#',$b);
                            $sp=$line[0];
                            $pon_id=$line[1];
                            $onu_id=$line[2];
                            $gem_id=$line[3];
                            $onu_info=str_replace('/','-',$pon_id)."-".$onu_id;
                            $info_id=$olt_id.'-'.$onu_info;
                            DB::insert(TBL_SP, [
                                'olt_id'=>$olt_id,
                                'service_port'=>$sp,
                                'gem_id'=>$gem_id,
                                'pon_id' => $pon_id,
                                'onu_id' => $onu_id,
                                'info_id'=>$info_id,
                                'last_update'=>$last_update,
                            ]);
                        }else{
                            $line=preg_split('# #',$b);
                            $pon_id=$line[0];
                            $onu_id=$line[1];
                            $serial=$line[2];
                            $status=$line[3];
                            $fw=$line[4];
                            $nome="";
                            if(isset($line[5])){
                                $nome=str_replace('_',' ',$line[5]);
                            }
                            $onu_info=str_replace('/','-',$pon_id)."-".$onu_id;
                            $info_id=$olt_id.'-'.$onu_info;
                            //echo "      ".$pon_id.", ".$onu_id.", ".$serial.", ".$status.", ".$fw.", ".$nome."\n";
                            DB::insert(TBL_ONU, [
                                'olt_id'=>$olt_id,
                                'onu_serial' => $serial,
                                'pon_id' => $pon_id,
                                'onu_id' => $onu_id,
                                'onu_name'=>$nome,
                                'onu_status'=>$status,
                                'fw_status'=>$fw,
                                'last_update'=>$last_update,
                                'onu_info'=>$onu_info,
                                'info_id'=>$info_id
                            ]);
                        }
                    }
                }
            }
        }
    }
function dm_onu_status($info){
        $ret=ERR_05;
        if($info!=""){
            $last_update=date('Y-m-d H:i:s');
            $line=preg_split("#-#",$info);
            $olt_id=$line[0];
            $pon_id=$line[1]."/".$line[2]."/".$line[3];
            $onu_id=$line[4];
            $cmd1='show interface gpon '.$pon_id.' onu '.$onu_id.' | nomore | display keypath ; ';
        
            $r=dm_cmd($olt_id,$cmd1);
            $ret["olt_id"]=$olt_id;
            
            $ret["pon_id"]=$pon_id;
            $ret["onu_id"]=$onu_id;
            $ret["onu_info"]=$pon_id."-".$onu_id;
            $reg["info_id"]=$info;
            $ret["onu_status"]=str_cut($r,"oper-state","\n");
            $ret["name"]=str_replace("_"," ",str_cut($r,"/name","\n"));

            $ret["rx"]=str_cut($r,"/rx-optical-pw","\n");
            $ret["tx"]=str_cut($r,"/tx-optical-pw","\n");
      
            $ret["vendor"]=str_cut($r,"/vendor-id","\n");
            $ret["serial"]=str_cut($r,"/serial-number","\n");
            $ret["model"]=str_cut($r,"eq-id","\n");
            $ret["fw"]=str_cut($r,"active-fw","\n");
            $ret["fw_status"]=str_cut($r,"/software-download-state","\n");

            $ret["uptime"]=str_replace("day",'dia',str_replace('"',"",str_cut($r,"uptime","\n")));
            $ret["distance"]=str_cut($r,"distance","\n").' km';
            
            $mix=str_cut($r,"/ethernet{1}","/link");
            $mb="Mbps - ";

            $ret["ether1_status"]=str_cut($r,"/ethernet{1}".$mix."/link","\n");
            if($ret["ether1_status"]!="Up"){
                $mb="";
            }
            $ret["ether1_speed"]=str_cut($r,"/ethernet{1}".$mix."/negotiatedSpeed","\n").$mb.str_cut($r,"/ethernet{1}".$mix."/negotiatedDuplex","\n");
            
            $ret["ether2_status"]=str_cut($r,"/ethernet{2}".$mix."/link","\n");
            if($ret["ether2_status"]!="Up"){
                $mb="";
            }
            $ret["ether2_speed"]=str_cut($r,"/ethernet{2}".$mix."/negotiatedSpeed","\n").$mb.str_cut($r,"/ethernet{2}".$mix."/negotiatedDuplex","\n");

            $ret["ether3_status"]=str_cut($r,"/ethernet{3}".$mix."/link","\n");
            if($ret["ether3_status"]!="Up"){
                $mb="";
            }
            $ret["ether3_speed"]=str_cut($r,"/ethernet{3}".$mix."/negotiatedSpeed","\n").$mb.str_cut($r,"/ethernet{3}".$mix."/negotiatedDuplex","\n");

            $ret["ether4_status"]=str_cut($r,"/ethernet{4}".$mix."/link","\n");
            if($ret["ether4_status"]!="Up"){
                $mb="";
            }
            $ret["ether4_speed"]=str_cut($r,"/ethernet{4}".$mix."/negotiatedSpeed","\n").$mb.str_cut($r,"/ethernet{4}".$mix."/negotiatedDuplex","\n");

             DB::insertUpdate(TBL_ONU, [
                            'olt_id'=>$olt_id,
                            'onu_serial' => $ret["serial"],
                            'pon_id' => $ret["pon_id"],
                            'onu_id' => $ret["onu_id"],
                            'onu_name'=>$ret["name"],
                            'onu_status'=>$ret["onu_status"],
                            'fw_status'=>$ret["fw_status"],
                            'last_update'=>$last_update,
                            'onu_info'=>$ret["onu_info"],
                            'info_id'=>$info,
                            'onu_rx'=>$ret["rx"]
                        ], [
                            'pon_id' => $ret["pon_id"],
                            'onu_id' => $ret["onu_id"],
                            'onu_name'=>$ret["name"],
                            'onu_status'=>$ret["onu_status"],
                            'fw_status'=>$ret["fw_status"],
                            'last_update'=>$last_update,
                            'onu_info'=>$ret["onu_info"],
                            'info_id'=>$info,
                            'onu_rx'=>$ret["rx"]
                        ]);
        }
    }
function ___________________dm_onu_free($olt_id,$pon_id){
        $query='select onu_id from '.TBL_ONU.' where olt_id="'.$olt_id.'" and pon_id="'.$pon_id.'" order by onu_id asc;';
        $results = DB::query($query);
        $ct=0;
        $next=-1;
        foreach ($results as $row) {   
            if($row["onu_id"]!=$ct and $next==-1){
                $next=$ct;
            }
            $ct++;
        }
        if($next==-1){
            if($ct<127){
                $next=$ct;
            }
        }
        $ret["next"]=$next;
        $ret["free"]=128-sizeof($results);
        return $ret;
    }
function dm_onu_free($olt_id,$pon_id,$qt){
        $ret=ERR_05;
        if($olt_id!="" and $pon_id!="" and $qt!=""){
            $query='select onu_id from '.TBL_ONU.' where olt_id="'.$olt_id.'" and pon_id="'.$pon_id.'" order by onu_id asc;';
            $results = DB::query($query);
            $ctn=0;
            $ret=[];
            $onu_next=[];
            foreach ($results as $row) {   
                $onu_free[$row["onu_id"]]=$row["onu_id"];
            }
            for ($i = 0; $i <= 127; $i++) {
                if(isset($onu_free[$i])){
                    $ctn++;
                }else{
                    if (sizeof($onu_next)>=$qt){
                        break;
                    }
                    $onu_next[]=$i;
                }
            }
            $ret["next"]=$onu_next;
            $ret["ocup"]=$ctn;
            $ret["free"]=128-$ctn;

        }
        return $ret;
    }
function dm_sp_free($olt_id,$qt){
        $query='select service_port from '.TBL_SP.' where olt_id="'.$olt_id.'" order by service_port asc;';
        $results = DB::query($query);
        $ct=0;
        $ctn=0;
        $next=-1;
        foreach ($results as $row) {   
            $sp[$row["service_port"]]=$row["service_port"];
            $ct++;
        }
        $spfree[]=0;
        for ($i = 1; $i <= 65535; $i++) {
           if(isset($sp[$i])!==true){
                $spfree[$ctn]=$i;
                if ($ctn>=$qt-1){
                    break;
                }
                $ctn++;
            }
        }        
        return $spfree;
    }
function dm_mac($olt_id,$pon_id,$onu_id){
        $query='select gem_id,service_port from '.TBL_SP.' where olt_id="'.$olt_id.'" and pon_id="'.$pon_id.'" and onu_id="'.$onu_id.'" order by gem_id asc;';
        $results = DB::query($query);
        $cmd='';
        foreach ($results as $row) {   
            $gem_id[$row["service_port"]]=$row["gem_id"];
            $cmd=$cmd.'show mac-address-table interface service-port-'.$row["service_port"].' | nomore ;';
        }
        $r=dm_cmd($olt_id,$cmd);
        $lines=preg_split("#\n#",$r);
        $qlines=sizeof($lines);
        $ct=0;
        for ($i = 0; $i <=$qlines-1; $i++) {
            $b=preg_replace('/( )+/', " ",$lines[$i]);
            if(strpos($b,'service-port')!==false){                
                $line=preg_split("#\ #",$b);
                $sp=$gem_id[str_replace('service-port-','',$line[0])];
                $devices[$sp][$line[2]][]=$line[1];
                $ct++;
            }
            
        }
        if($ct==0){
            $devices="";
        }
        return $devices;
    }
function dm_ip($olt_id,$pon_id,$onu_id){
        $query='select gem_id,service_port from '.TBL_SP.' where olt_id="'.$olt_id.'" and pon_id="'.$pon_id.'" and onu_id="'.$onu_id.'" order by gem_id asc;';
        $results = DB::query($query);
        $cmd='';
        foreach ($results as $row) {   
            $gem_id[$row["service_port"]]=$row["gem_id"];
            $cmd=$cmd.'show allowed-ip interface service-port-'.$row["service_port"].' | nomore ;';
        }
        $r=dm_cmd($olt_id,$cmd);
        $lines=preg_split("#\n#",$r);
        $qlines=sizeof($lines);
        $ct=0;
        for ($i = 0; $i <=$qlines-1; $i++) {
            $b=preg_replace('/( )+/', " ",$lines[$i]);
            if(strpos($b,':')!==false){                
                $line=preg_split("#\ #",$b);
                $sp=$gem_id[str_replace('service-port-','',$line[4])];
                $devices[$sp][$line[2]][$line[0]]=$line[1];
                $ct++;
            }
            
        }
        if($ct==0){
            $devices="";
        }
        return $devices;
   }
function dmcode_remove_onu($olt_id,$serial){
        $ret=ERR_05;
        if($olt_id!="" and $serial!=""){
            $ret=ERR_07;
            $query='select pon_id,onu_id from '.TBL_ONU.' where olt_id="'.$olt_id.'" and onu_serial="'.$serial.'" limit 1;';
            $row = DB::queryFirstRow($query);
            if(isset($row)){
                $pon_id=$row["pon_id"];
                $onu_id=$row["onu_id"];
                $cmd="";
                $cmd=$cmd."interface gpon ".$pon_id."\n";
                $cmd=$cmd." no onu ".$onu_id."\n";
                $cmd=$cmd."!\n";
                $query='select gem_id,service_port from '.TBL_SP.' where olt_id="'.$olt_id.'" and pon_id="'.$pon_id.'" and onu_id="'.$onu_id.'" order by gem_id asc;';
                $results = DB::query($query);
                foreach ($results as $row) {   
                    $cmd=$cmd.'no service-port '.$row["service_port"]." ; top ; \n";
                    $cmd=$cmd."anti-ip-spoofing; no interface service-port-".$row["service_port"]." ; top ; \n";
                    $ret=$cmd;
                }
            }
            
        }
        return $ret;

    }
function dm_commit($olt_id,$code,$commit){
        $ret=ERR_05;
        if($olt_id!="" and $code!="" and $commit!=""){
            $cmd= "config;\n";
            $cmd=$cmd.$code;
            if($commit==true){
                $cmd=$cmd."commit and-quit;\n";
            }else{
                $cmd=$cmd."commit check;\n";
                $cmd=$cmd."commit abort;\n";
                $cmd=$cmd."top;\n";
                $cmd=$cmd."exit no-confirm;\n";
            }
            $ret=dm_cmd($olt_id,$cmd);
            if(strpos(strtolower($r),strtolower(C_COMPLETE))!==false){
                $ret= ERR_00;
            }elseif (strpos(strtolower($r),strtolower(V_COMPLETE))!==false){
                $ret=ERR_01;
            }
        }
        return $ret;
    }
function dm_del_onu($olt_id,$pon_id,$onu_id,$commit){
        $query='select gem_id,service_port from '.TBL_SP.' where olt_id="'.$olt_id.'" and pon_id="'.$pon_id.'" and onu_id="'.$onu_id.'" order by gem_id asc;';
        $results = DB::query($query);
        $cmd="";
        $cmd=$cmd."config;\n";
        $cmd=$cmd."interface gpon ".$pon_id." ;\n";
        $cmd=$cmd."no onu ".$onu_id.";\n";
        $cmd=$cmd."top;\n";
        //die($query);
        foreach ($results as $row) {   
            $cmd=$cmd.'no service-port '.$row["service_port"]." ;\n";
            $cmd=$cmd."top;\n";
            $cmd=$cmd."anti-ip-spoofing;\n";
            $cmd=$cmd."no interface service-port-".$row["service_port"]." ;\n";
            $cmd=$cmd."top;\n";
        }
        if($commit==true){
            $cmd=$cmd."commit and-quit;\n";
        }else{
            $cmd=$cmd."commit check;\n";
            $cmd=$cmd."commit abort;\n";
            $cmd=$cmd."top;\n";
            $cmd=$cmd."exit no-confirm;\n";
        }
        $r=dm_cmd($olt_id,$cmd);
        if(strpos(strtolower($r),strtolower(C_COMPLETE))!==false){
            $query1='delete from '.TBL_ONU.' where olt_id="'.$olt_id.'" and pon_id="'.$pon_id.'" and onu_id="'.$onu_id.'";';
            $query2='delete from '.TBL_SP.' where olt_id="'.$olt_id.'" and pon_id="'.$pon_id.'" and onu_id="'.$onu_id.'";';
            DB::query($query1.$query2);
        }
        return $r;
    }
function dm_pon($info_id){// InStr: InfoId; OutArray: olt,gpon,onu
        $ret=ERR_05;
        if($info_id!=""){
            $ret=[];
            $arr=explode('-',$info_id);
            $ret["olt"]=$arr[0];
            $ret["gpon"]=$arr[1]."/".$arr[2]."/".$arr[3];
            $ret["onu"]=$arr[4];
        }
        return $ret;
    }
function dmcode_del_onu($info_id){
        $ret=ERR_05;
        if($info_id!=""){
            $query='SELECT concat(CONCAT("interface gpon ",dm_pon(_onus.info_id)," ; no onu ",dm_onu(_onus.info_id)," ; top ; \n"),CONCAT("no service-port ",group_concat(_service_port.service_port)," ; top;\n"),CONCAT("anti-ip-spoofing; ",GROUP_CONCAT("no interface service-port-",_service_port.service_port SEPARATOR " ; ")," ; top; \n")) AS cmd   
            FROM _onus LEFT JOIN _service_port ON _service_port.olt_id=_onus.olt_id AND _service_port.info_id=_onus.info_id
             WHERE _onus.info_id="'.$info_id.'"';
            $row = DB::queryFirstRow($query);
            $ret=$row["cmd"];
        }
        return $ret;
    }
function dm_info_onu($olt_id,$serial){// InStr: olt_id,serial; OutArr; gpon,onu,cfg
        $ret=ERR_05;
        if($olt_id!="" and $serial!=""){
            $ret=ERR_07;
            $query='select pon_id,onu_id from '.TBL_ONU.' where olt_id="'.$olt_id.'" and onu_serial="'.$serial.'" limit 1;';
            $row = DB::queryFirstRow($query);
            if(isset($row)){
                $pon_id=$row["pon_id"];
                $onu_id=$row["onu_id"];
                $query='select service_port from '.TBL_SP.' where olt_id="'.$olt_id.'" and pon_id="'.$pon_id.'" and onu_id="'.$onu_id.'" order by gem_id asc;';
                $results = DB::query($query);
                $cmd="";
                $cmd='show running-config interface gpon '.$pon_id.' onu '.$onu_id." ;\n";
                foreach ($results as $row) {   
                    $cmd=$cmd.'show running-config service-port '.$row["service_port"]." ;\n";
                }
                $cfg["gpon"]=$pon_id;
                $cfg["onu"]=$onu_id;
                $cfg["cfg"]=dm_cmd($olt_id,$cmd);
                $ret=$cfg;
            }
        }
            return $ret;
    }
function dm_info_onu2($olt_id,$gpons,$service_ports){// InStr: olt_id, gpons=1/1/1 onu 1,2,3,4...
        $ret=ERR_05;
        if($olt_id!="" and $gpons){
            $cmd='show running-config interface gpon '.$gpons.' onu';
        }
    }
function dm_is_prov($olt_id,$serial){
        $ret=ERR_05;
        if($olt_id!="" and $serial!=""){
            $query='select pon_id from '.TBL_ONU.' where olt_id="'.$olt_id.'" and onu_serial="'.$serial.'" limit 1;';
            $row = DB::queryFirstRow($query);
            $ret=ERR_07;
            if(isset($row)){
                $ret=$row["pon_id"];
            }
        }
        return $ret;
    }
function dmcode_reprov($olt_id,$serial,$src_gpon,$dst_gpon){
        $ret=dm_info_onu($olt_id,$serial);
        if(strpos($ret,'-err ')===false){
            $src_gpon=$ret["gpon"];
            $src_onu=$ret["onu"];
            $cfg_onu=$ret["cfg"];
            $ret=ERR_05;
            if($src_gpon!="" and $src_onu!=""){
                $ret=ERR_40;
                $r=dm_onu_free($olt_id,$dst_gpon,1);
                if($r["free"]<=128){
                    $dst_onu=$r["next"][0];
                    $cfg_onu=str_replace("gpon ".$src_gpon."\n","gpon ".$dst_gpon."\n",$cfg_onu);
                    $cfg_onu=str_replace("gpon ".$src_gpon." ","gpon ".$dst_gpon." ",$cfg_onu);
                    $cfg_onu=str_replace("onu ".$src_onu."\n","onu ".$dst_onu."\n",$cfg_onu);
                    $cfg_onu=str_replace("onu ".$src_onu." ","onu ".$dst_onu." ",$cfg_onu);
                    $cfg_del="";
                    $cfg_del=$cfg_del."interface gpon ".$src_gpon."\n";
                    $cfg_del=$cfg_del." no onu ".$src_onu."\n";
                    $cfg_del=$cfg_del."!\n";
                    $ret=$cfg_del.$cfg_onu;
                }
            }
        }
        return $ret;
    }
function dmcode_prov($olt_id,$serial,$dst_gpon,$nome,$template){
        $ret=ERR_05;
        if($olt_id!="" and $serial!="" and $dst_gpon!=""){
            $src_gpon=dm_is_prov($olt_id,$serial);
            if(strpos($src_gpon,ERR_07)===false){
                $ret=dm_reprov($olt_id,$serial,$src_gpon,$dst_gpon,$commit);
            }else{
                $ret=ERR_60;
                $query='select template from '.TBL_TEMPLATES.' where olt_id="'.$olt_id.'" and nome="'.$template.'" limit 1;';
                $row = DB::queryFirstRow($query);
                if(isset($row)){
                    $onu_free=dm_onu_free($olt_id,$dst_gpon,1);
                    $sp=dm_sp_free($olt_id,5);
                    $cfg=$row["template"];
                    $nome=str_clear($nome,"name");
                    $cfg=str_replace('{SERIAL}',$serial,$cfg);
                    $cfg=str_replace('{GPON}',$dst_gpon,$cfg);
                    $cfg=str_replace('{ONU}',$onu_free["next"][0],$cfg);
                    $cfg=str_replace('{NAME}',$nome,$cfg);
                    $cfg=str_replace('{SERVICE-PORT-1}',$sp[1],$cfg);
                    $ret=$cfg;
                }
            }
        }
        return $ret;
    }
function dmcode_reprov_mass($olt_id){
        $ret=ERR_05;
        if($olt_id!=""){
            $ret=ERR_03;
            $query='call dmp_reprov_mass("'.$olt_id.'");';
            //echo $query;
            $results2 = DB::query($query);
            foreach ($results2 as $row2) {   
                $cfg_onu=dm_cmd($olt_id,$row2["info_onus"]);
                
                $src_gpon=$row2["src_gpon"];
                $dst_gpon=$row2["dst_gpon"];
                $array_src_onus=explode(',',$row2["src_onus"]);
                $array_dst_onus=explode(',',$row2["dst_onus"]);
                
                $qlines=sizeof($array_src_onus);
                
                $cfg_del="interface gpon ".$src_gpon."\n";
                $cfg_del=$cfg_del." no onu ".$row2["src_onus"]."\n";
                $cfg_del=$cfg_del."!\n";
                for ($i = 0; $i <=$qlines-1; $i++) {
                    $src_onu=$array_src_onus[$i];
                    $dst_onu=$array_dst_onus[$i];
                    
                    $cfg_onu=str_replace("gpon ".$src_gpon."\n","gpon ".$dst_gpon."\n",$cfg_onu);
                    $cfg_onu=str_replace("gpon ".$src_gpon." ","gpon ".$dst_gpon." ",$cfg_onu);
                    $cfg_onu=str_replace("onu ".$src_onu."\n","onu ".$dst_onu."\n",$cfg_onu);
                    $cfg_onu=str_replace("onu ".$src_onu." ","onu ".$dst_onu." ",$cfg_onu);        
                }
                $ret=$cfg_del.$cfg_onu."top ;\n";
            }
        }
        return $ret;
    
    }
 
function code_cut($code,$tag1,$tag2,$is_true="",$is_false=""){
        $code=preg_replace("#\r#","",$code);
        
        $ret=$is_false;
        //$t=preg_match_all('#'.$tag1.'(.+?)'.$tag2.'.+0#is', $code, $array_saida);
        $analize='#'.$tag1.'(.+?)'.$tag2.'#s';
        //die($analize);
        $t=preg_match_all($analize, $code, $array_saida);
        if($t>=1){
            $ret=$array_saida[1][0];
            if(strpos($ret,$tag2)!==false){
                $ret=trim($is_true);
            }
            $ret=trim($ret);
        }
        return $ret;
    }
function dmcode_block_onu($code,$pon,$onu){

        $ret="";
        $code=preg_replace("#\r#","",$code);
        $t=preg_match_all('#interface gpon '.$pon.'(.+?)\n!#is', $code, $bloco_pon);
        if ($t >= 1) {
            $t=preg_match_all('# onu '.$onu.'(.+?)\n !#is', $bloco_pon[0][0], $bloco_onu);
            if ($t >= 1) {
                $ret=$bloco_onu[0][0];
            }
        }
        return $ret;
    }
function debug($debug,$msg){
    $pre1="";
    $pre2="";
    $lf="\n";
    $isCLI = ( php_sapi_name() == 'cli' );
    if($isCLI!=1){
        $pre1="<pre>";
        $pre2="</pre>";    
        $lf="<br>";
    }
    if($debug=='true'){
        if (gettype($msg)=="array"){
            echo($pre1);
                print_r($msg);
            echo($pre2);
        }else{
            echo($pre1."    ".$msg.$lf.$pre2);
        }
        
    }
    }
    function dm2sql_onusp($olt,$debug){
        $ret=ERR_03;
        //---[ Carrega tabela _onus]
        debug($debug,"Carregando tabela ".TBL_ONU);
        $query1='SELECT pon_id,onu_id,ipv4_vlan,eth1_nvlan,eth2_nvlan,eth3_nvlan,eth4_nvlan FROM _onus where olt_id="'.$olt.'"';
        $rows1 = DB::query($query1);
        if(isset($rows1)===false){
            die(ERR_06);
        }
        foreach ($rows1 as $key => $row) {   
            $index=str_replace("/","/",$row["pon_id"])."-".$row["onu_id"];
            $tbl_onus[$index]=array($row["ipv4_vlan"],$row["eth1_nvlan"],$row["eth2_nvlan"],$row["eth3_nvlan"],$row["eth4_nvlan"]);
        }
        //---[Carrega tabela _service_ports]
        debug($debug,"Carregando tabela ".TBL_SP);
        $query2='SELECT * FROM _service_port where olt_id="'.$olt.'";';
        $rows2 = DB::query($query2);
        if(isset($rows2)===false){
            die(ERR_06);
        }
        debug($debug,"Processando Services Ports nas ONUS");
        foreach ($rows2 as $key => $row) {   
            $eth="";
            $p=array();
            $index=str_replace("/","/",$row["pon_id"])."-".$row["onu_id"];
            //$p["id_empresa"]=$row["id_empresa"];
            $p["olt_id"]=$row["olt_id"];
            $p["pon_id"]=$row["pon_id"];
            $p["onu_id"]=$row["onu_id"];
            
        
            $pvlan=$row["in_vlan"];
            $check=$tbl_onus[$index];
            if($pvlan!=""){
                if($check[0]==$pvlan){$eth="ipv4_";}
                if($check[1]==$pvlan){$eth="eth1_";}
                if($check[2]==$pvlan){$eth="eth2_";}
                if($check[3]==$pvlan){$eth="eth3_";}
                if($check[4]==$pvlan){$eth="eth4_";}
                if($eth=="ipv4_"){
                    $p["ipv4_sp"]=$row["sp"];
                    $p["ipv4_gem"]=$row["gem_id"];
                    $p["ipv4_action"]=$row["action"];
                    $p["ipv4_outvlan"]=$row["out_vlan"];
                    if($p["ipv4_action"]=="replace"){$p["ipv4_action"]="1";}elseif($p["ipv4_action"]=="add"){$p["ipv4_action"]="2";}
                    $query3='UPDATE '.TBL_ONU.' SET ipv4_sp="'.$p["ipv4_sp"].'", ipv4_gem="'.$p["ipv4_gem"].'", ipv4_action="'.$p["ipv4_action"].'", ipv4_outvlan="'.$p["ipv4_outvlan"].'" WHERE olt_id="'.$olt.'" AND pon_id="'.$row["pon_id"].'" AND onu_id="'.$row["onu_id"].'" LIMIT 1;';    
                }else{
                    $p[$eth."sp"]=$row["sp"];
                    $p[$eth."gem"]=$row["gem_id"];
                    $p[$eth."action"]=$row["action"];
                    $p[$eth."outvlan"]=$row["out_vlan"];
                    $p[$eth."innervlan"]=$row["inner_vlan"];
                    if($p[$eth."action"]=="replace"){$p[$eth."action"]="1"; }elseif($p[$eth."action"]=="add"){$p[$eth."action"]="2";}
                    $query3='UPDATE '.TBL_ONU.' SET '.$eth.'sp="'.$p[$eth."sp"].'", '.$eth.'nvlan="'.$pvlan.'", '.$eth.'gem="'.$p[$eth."gem"].'",'.$eth.'action="'.$p[$eth."action"].'",'.$eth.'outvlan="'.$p[$eth."outvlan"].'",'.$eth.'innervlan="'.$p[$eth."innervlan"].'" WHERE olt_id="'.$olt.'" AND pon_id="'.$row["pon_id"].'" AND onu_id="'.$row["onu_id"].'" LIMIT 1;';
                }
                
                //$p[$eth]=$pvlan;
                //$p[$eth."nvlan"]=$pvlan;
                debug($debug,$query3);
                //DB::query($query3);
                DB::query($query3);
                
                
            }
        }



    }
    function dm2sql_sp($olt,$debug,$pon="",$onu=""){
        $mask="";
        debug($debug,"Coletando Services Ports");
        if($pon!="" and $onu!=""){
            $mask='| include ",'.$gpon.'","'.$onu.'," ';
            DB::query('DELETE FROM '.TBL_SP.' WHERE olt_id="'.$olt.'" and pon_id="'.$pon.'" and onu_id="'.$onu.'";');
        }elseif($pon!=""){
            $mask='| include ",'.$gpon.'," ';
            DB::query('DELETE FROM '.TBL_SP.' WHERE olt_id="'.$olt.'" and pon_id="'.$pon.'";');
        }
        $cmd1='show running-config service-port | tab | csv | nomore '.$mask.';';
        $code=dm_cmd($olt,$cmd1);
        debug($debug,"Processando Services Ports.");        
        $lines=preg_split('#\n#',$code);
        $qlines=sizeof($lines);
        $arr1=array();
        for ($i = 0; $i <=$qlines-1; $i++) {
            $b=trim(preg_replace('/( )+/', " ",$lines[$i]));
            if(strpos($b,'/')!==false){
                if(strpos($b,',')!==false){
                    //$p["id_empresa"]=$row["id_empresa"];
                    $p["olt_id"]=$olt;
                    $line=preg_split('#,#',$b);
                    $p["last_update"]=date("Y-m-d H:i:s");
                    $p["inner_vlan"]="";
                    $p["sp"]=$line[0];
                    $p["pon_id"]=$line[1];
                    $p["onu_id"]=$line[2];
                    $p["gem_id"]=$line[3];
                    $p["in_vlan"]=$line[4];
                    
                    $p["action"]=$line[6];
                    $p["out_vlan"]=$line[7];
                    
                    $p["inner_vlan"]=$line[9];
                    $p["desc"]=$line[10];
                    $is_any=$line[5];
                    if($is_any!="-"){
                        $p["in_vlan"]="";
                    }
                    $is_inner=$line[8];
                    if($is_inner=="-"){
                        $p["inner_vlan"]="";
                    }
                    if($p["desc"]=="-"){
                        $p["desc"]="";
                    }
                    if($p["action"]=="add"){
                        $p["action"]="2";
                    }
                    if($p["action"]=="replace"){
                        $p["action"]="1";
                    }
                    
                    //$onu_info=str_replace('/','-',$pon_id)."-".$onu_id;
                    //$info_id=$olt_id.'-'.$onu_info;
                    DB::insertUpdate(TBL_SP, $p);
                    debug($debug,$p);
                }
            }
        }
    }
    
    function dm2sql_onu($olt,$debug,$pon="",$onu=""){
    if($olt==""){
        die(ERR_05);
    }
    if($pon!=""){$pon=$pon."\n";}
    if($onu!=""){$onu=$onu."\n";}
    $ns="\n   no negotiation\n   speed ";
    debug ($debug,"Acessando OLT");
    $code=dm_cmd($olt,"show running-config | nomore ;");
    $code=preg_replace("#\r#","",$code);
    $ret=ERR_03;
    
    debug ($debug,"Recebido Configurações. Processando");
    if($pon!=""){
        DB::query('DELETE FROM '.TBL_ONU.' WHERE olt_id="'.$olt.'" and pon_id="'.$pon.'";');
    }else{
        DB::query('DELETE FROM '.TBL_ONU.' WHERE olt_id="'.$olt.'";');
    }
    $qt_pon_block=preg_match_all('#\ninterface gpon '.$pon.'(.+?)\n!#s', $code, $pon_block_array);
    for ($i = 0; $i <=$qt_pon_block-1; $i++) {
        $pon_block=$pon_block_array[0][$i];
        $pon_id=code_cut($pon_block,"gpon ","\n");
        $pon_mode=code_cut($pon_block,"\n no shutdown","\n","1","");
        $qt_onu_block=preg_match_all('#\n onu '.$onu.'(.+?)\n !#s', $pon_block, $onu_block_array);
        $p=array();
        $p["olt_id"]=$olt;
        //$p["id_empresa"]=$row["id_empresa"];
        for ($ii = 0; $ii <=$qt_onu_block-1; $ii++) {
            $onu_block=$onu_block_array[0][$ii];
            $p["pon_id"]=$pon_id;
            $p["onu_id"]=code_cut($onu_block,"\n onu ","\n");
            $p["onu_serial"]=code_cut($onu_block,'serial-number ',"\n");
            $p["onu_name"]=code_cut($onu_block,"\n  name ","\n");
            $p["line_profile"]=code_cut($onu_block,"\n  line-profile ","\n");
            $p["ipv4_mode"]=code_cut($onu_block,"\n  ipv4 static"," ","1","").code_cut($onu_block,"\n  ipv4 dhcp","\n","2","");
            $p["ipv4_ip"]=code_cut($onu_block,"\n  ipv4 static address ","(\ |\n)","","");
            $p["ipv4_gw"]=code_cut($onu_block,"\n  ipv4 static.*default-gateway","\n","","");
            $p["ipv4_vlan"]=code_cut($onu_block,"\n  ipv4 vlan vlan-id","(\ |\n)","","");
            $p["ipv4_cos"]=code_cut($onu_block,"\n  ipv4 vlan vlan-id [\w]+ cos", "\n","","");

            $qt_eth_block=preg_match_all('#\n  ethernet (.+?)\n  !#s', $onu_block, $eth_block_array);
            
            $ct=1;
            $pp=array();
            for ($iii= 0; $iii <=$qt_eth_block-1; $iii++) {
                $iface="eth".$ct."_";
                $eth_block=$eth_block_array[0][$iii];
                $iauto=code_cut($eth_block,"\n   negotiation", "\n","1","");
                $iveip=code_cut($eth_block,"\n  veip 1", "\n","9","");
                $ifd1000=code_cut($eth_block,$ns."1000 duplex full", "\n","2","");
                $ifh1000=code_cut($eth_block,$ns."1000 duplex half", "\n","3","");
                $ifd100=code_cut($eth_block,$ns."100 duplex full", "\n","4","");
                $ifh100=code_cut($eth_block,$ns."100 duplex half", "\n","5","");
                $ifd10=code_cut($eth_block,$ns."10 duplex full", "\n","6","");
                $ifh10=code_cut($eth_block,$ns."10 duplex half", "\n","7","");
                $ioff=code_cut($eth_block,"\n   shutdown", "\n","8","");
                
                $pp[$iface."mode"]=$iauto.$ifd1000.$ifh1000.$ifd100.$ifh100.$ifd10.$ifh10.$ioff;
                $pp[$iface."lmac"]=code_cut($eth_block,"\n   mac-limit", "\n");
                $pp[$iface."nvlan"]=code_cut($eth_block,"\n   native vlan vlan-id", "\n");
                $pp[$iface."ncos"]=code_cut($eth_block,"\n   native vlan cos", "\n");
                $pp[$iface."desc"]=code_cut($eth_block,"\n   description", "\n");
                
                $ct=$ct+1;
            }
            $ret=array_merge($p,$pp);
            
            debug($debug,$ret);                
            DB::insert(TBL_ONU, $ret);
        }
    }
    return $ret;
}

function dmcode_check($olt,$debug="",$setmd5=""){
    $ret=array();
    if($setmd5!=""){
        $check_date=date("Y-m-d H:i:s");
        $query='update '.TBL_OLT.' set check_md5="'.$setmd5.'", check_update="'.$check_date.'" where olt_id="'.$olt.'" limit 1;';
        DB::query($query);
        debug($debug,"Alteracoes Confirmadas.");
        return "";
    }
    debug($debug,"Verificando Atualizacoes na OLT...");
    $query='select check_md5 from '.TBL_OLT.' where olt_id="'.$olt.'" limit 1;';
    $row = DB::queryFirstRow($query);
    if(isset($row)===false){
        die(ERR_06);
    }
    $cmd='show configuration commit changes 0 | nomore;';
    $code=dm_cmd($olt,$cmd);
    $check_code=md5($code);
    if($check_code!=$row["check_md5"]){
        debug($debug,"Alteracoes Detectadas...: ".$check_code."\n");
    }else{
        debug($debug,"Sem Alteracoes na OLT.");
        $check_code="";
    }
    $ret["code"]=$code;
    $ret["check"]=$check_code;
    return $ret;
}
function dm2arr ($code,$debug){
    debug($debug,"Processando Services Ports.");    
    $qt_sp_block=preg_match_all('#\nservice-port (.+?)\n!#s', $code, $sp_block_array);
    for ($i = 0; $i <=$qt_sp_block-1; $i++) {
        $sp_block=$sp_block_array[0][$i];
        $p["sp"]=code_cut($sp_block,"service-port","\n");
        $p["gem"]=code_cut($sp_block," gem "," ");
        $p["invlan"]=code_cut($sp_block,"match vlan vlan-id "," ");
        $p["action"]=code_cut($sp_block,"action vlan "," ");
        $p["outvlan"]=code_cut($sp_block,"action vlan [\w]+ vlan-id ","(\n|\ )");
        $p["innervlan"]=code_cut($sp_block,"inner-vlan replace vlan-id","\n|\ ");
        $p["desc"]=code_cut($sp_block,"description","\n");
        print_r($p);
    }
}
function dm2sql_onu2($code,$debug){
    $code=preg_replace("#\r#","",$code);
    $ns="\n   no negotiation\n   speed ";
    $qt_pon_block=preg_match_all('#\ninterface gpon (.+?)\n!#s', $code, $pon_block_array);
    for ($i = 0; $i <=$qt_pon_block-1; $i++) {
        $pon_block=$pon_block_array[0][$i];
        $pon_id=code_cut($pon_block,"gpon ","\n");
        $pon_mode=code_cut($pon_block,"\n no shutdown","\n","1","");
        $qt_onu_block=preg_match_all('#\n onu (.+?)\n !#s', $pon_block, $onu_block_array);
        $p=array();
        for ($ii = 0; $ii <=$qt_onu_block-1; $ii++) {
            $onu_block=$onu_block_array[0][$ii];
            $p["pon_id"]=$pon_id;
            $p["onu_id"]=code_cut($onu_block,"\n onu ","\n");
            $p["onu_serial"]=code_cut($onu_block,'serial-number ',"\n");
            $p["onu_name"]=code_cut($onu_block,"\n  name ","\n");
            $p["line_profile"]=code_cut($onu_block,"\n  line-profile ","\n");
            $p["ipv4_mode"]=code_cut($onu_block,"\n  ipv4 static"," ","1","").code_cut($onu_block,"\n  ipv4 dhcp","\n","2","");
            $p["ipv4_ip"]=code_cut($onu_block,"\n  ipv4 static address ","(\ |\n)","","");
            $p["ipv4_gw"]=code_cut($onu_block,"\n  ipv4 static.*default-gateway","\n","","");
            $p["ipv4_vlan"]=code_cut($onu_block,"\n  ipv4 vlan vlan-id","(\ |\n)","","");
            $p["ipv4_cos"]=code_cut($onu_block,"\n  ipv4 vlan vlan-id [\w]+ cos", "\n","","");

            $qt_eth_block=preg_match_all('#\n  ethernet (.+?)\n  !#s', $onu_block, $eth_block_array);
        
            $ct=1;
            $pp=array();
            for ($iii= 0; $iii <=$qt_eth_block-1; $iii++) {
                $iface="eth".$ct."_";
                $eth_block=$eth_block_array[0][$iii];
                $iauto=code_cut($eth_block,"\n   negotiation", "\n","1","");
                $iveip=code_cut($eth_block,"\n  veip 1", "\n","9","");
                $ifd1000=code_cut($eth_block,$ns."1000 duplex full", "\n","2","");
                $ifh1000=code_cut($eth_block,$ns."1000 duplex half", "\n","3","");
                $ifd100=code_cut($eth_block,$ns."100 duplex full", "\n","4","");
                $ifh100=code_cut($eth_block,$ns."100 duplex half", "\n","5","");
                $ifd10=code_cut($eth_block,$ns."10 duplex full", "\n","6","");
                $ifh10=code_cut($eth_block,$ns."10 duplex half", "\n","7","");
                $ioff=code_cut($eth_block,"\n   shutdown", "\n","8","");
                
                $pp[$iface."mode"]=$iauto.$ifd1000.$ifh1000.$ifd100.$ifh100.$ifd10.$ifh10.$ioff;
                $pp[$iface."lmac"]=code_cut($eth_block,"\n   mac-limit", "\n");
                $pp[$iface."nvlan"]=code_cut($eth_block,"\n   native vlan vlan-id", "\n");
                $pp[$iface."ncos"]=code_cut($eth_block,"\n   native vlan cos", "\n");
                $pp[$iface."desc"]=code_cut($eth_block,"\n   description", "\n");
                
                $ct=$ct+1;
            }
            $ret=array_merge($p,$pp);
            debug($debug,$ret);       
        }
    }
} 
//*********************************************************** */
$olt='4707840';
    $debug="true";

    $ch=dmcode_check("4707840","true");
    $check=$ch["check"];
    if($check!=""){
        $x=dm2sql_onu($olt,$debug);
        $x=dm2sql_sp($olt,$debug);
        $x=dm2sql_onusp($olt,$debug);
        dmcode_check($olt,$debug,$check);
        debug($debug,"Terminado!!\n");
    }
    //$code=dm_cmd("4707840","show configuration commit changes 0 | nomore ;");

  
$code1=$ch["code"];
//$code2=$ch["code"];
$code=$code1.$code2;
echo $code;
    $x=dm2sql_onu2($code,$debug);
    $x=dm2arr($code,$debug);
    //$x=dmcode_block_onu($tudo,'1/1/8',"9");
    //$x=code_cut($tudo,"\ninterface gpon 1/1/1","\n onu");
    //print_r($x);
//print_r($x);

//DB::update('update '.TBL_OLT.' set check_update="'.$check_code.'" where olt_id="'.$olt.'" limit 1;');
//$x=dmcode_check("4707840","true");
//echo $x;
?>
