<?php
$help="";
$js="";
$html="";
$ahtml="";
$cmd_next="";
$run=false;
$title="";
define('HTML_HEAD','#html_head');
define('TFTP_SERVER','200.195.143.29');
define('TFTP_PATH',"tftp://".TFTP_SERVER."/");
define('TFTP_DOWNLOAD','request firmware onu add '.TFTP_PATH);
define('TFTP_ROOT_FIRMWARE_PATH','/home/dom/www/datacom/firmware/');

define('ERR_COLOR',"coral");
define('ERR_ONU_FW_CHECK_NO','Escolha um Firmware ai caraio....');
define('ERR_ONU_FW_CHECK_NOT','Equipamento sem Firmware (capeta)');
include_once "lib.php";
function js_alert_info($title,$msg){
    $html='$.alert({title: "<div class=\'mytitle-16\'>'.$title.'</div>",useBootstrap: false,icon: "fa fa-question",theme: "dark",type: "orange",draggable: true,boxWidth: arr_cfg.jsconfirm_size,content: "<div class=\'mytitle-16\'>'.$msg.'</div>"});';
    return $html;
}
function help($cmd,$opc){
    $ret="Sem Help Configurado para este Comando";
    $msg["onu_reboot"]["opc_reboot"]="Esta Opcao Reinicia a ONU<br>Isso demora mais ou menos 2 minutosx;";
    if($opc==""){
        if(isset($msg[$cmd])){
            $ret=$msg[$cmd];
        }
    }else{
        if(isset($msg[$cmd][$opc])){
            $ret=$msg[$cmd][$opc];
        }
    }
    
    return css_html($ret,"orb","coral","left");
}
function css_html($html,$theme="code",$color="white",$align="center",$size="14",$bold=false){
    if($theme=="code"){
        return '<div style="color:'.$color.';text-align:'.$align.'; font-size:'.$size.'px;"><code>'.$html.'</code></div>';   
    }elseif($theme=="orb"){
        return '<div style="font-family: \'Orbitron\', sans-serif;color: '.$color.'; font-size: '.$size.'px; text-align:'.$align.';">'.$html.'</div>';
    }
}

function js_header($timeout,$msg){
    $header="#html_head";
    $msg="<code>".$msg."</code>";
    $html='$("'.$header.'").html("'.$msg.'<hr>");';
    $html=$html.'$("'.$header.'").css("color","coral");';
    $html=$html.'setTimeout(function(){$("'.$header.'").html("");},'.$timeout.');';
    return $html;
}
function js_btshow($btn,$is_show=true){
    if($is_show==false){
        return '$("button:contains(\''.$btn.'\')").hide();';
    }else{
        return '$("button:contains(\''.$btn.'\')").show();';
    }
}
function js_bttitle($btn_old,$btn_new){
    return '$("button:contains(\''.$btn_old.'\')").html("'.$btn_new.'");';
}
function html_format($cor,$html){
    return '<div class="mytitle-22" style="color: '.$cor.';">'.$html.'</div>';
}


function hfilesize($bytes, $decimals = 2) {
    $sz = 'BKMGTP';
    $factor = floor((strlen($bytes) - 1) / 3);
    return sprintf("%.{$decimals}f", $bytes / pow(1024, $factor)) . @$sz[$factor];
  }

function dm_onu_update($olt,$pon,$onu){//Formato da url: 10.9.9.254/1056-07.bin ou 200.195.143.29/1056-07.bin
    $cmd='request firmware onu add tftp://'.$url;
}
function form_decode($form_array){
    $ret=array();
    foreach( $form_array as $array => $val ){
        $ret[$val["name"]]=$val["value"];
    }
    return $ret;
}
function dm_onu_fw_list($onu_model){
    $ret="";
    $html='<form id="form_html" action="/action_page.php">{opc_list}</form>';
    $directory = TFTP_ROOT_FIRMWARE_PATH.$onu_model;
    $files = array();
    $allowed_ext = array( "bin","pddf"); 
    if (file_exists($directory) && is_dir($directory)) {
        $scan_contents = scandir($directory);
        $files_array = array_diff($scan_contents, array('.', '..'));
        foreach ($files_array as $file) {
            $file_path = "$directory/$file";
            $md5=md5_file($file_path,false);
            $opc='<input type="radio" name="opc_fw" value="'.$file."|".$md5.'">';
            $file_ext = strtolower(pathinfo($file_path, PATHINFO_EXTENSION));        
            if (in_array($file_ext, $allowed_ext) ) {
                $files[] = $file_path;
                
                $ret=$ret.$opc." ".$onu_model."/".$file." | ".hfilesize(filesize($directory."/".$file))." | ".$md5."<br>";
            }
        }
    } 
    if($ret!=""){
        $ret=str_replace('{opc_list}',$ret,$html);

    }
    return $ret;
}
function dm_onu_status2($olt,$pon,$onu){
    $last_update=date('Y-m-d H:i:s');

    $cmd1='show interface gpon '.$pon.' onu '.$onu.' | nomore | display curly-braces ; ';

    $r=dm_cmd($olt,$cmd1);
    $ret["last_update"]=$last_update;
    $ret["onu_status"]=code_cut($r,"oper-state",";");
    $ret["onu_name"]=str_replace("_"," ",code_cut($r,"name",";"));

    $ret["onu_rx"]=code_cut($r,"rx-optical-pw",";");
    $ret["onu_tx"]=code_cut($r,"tx-optical-pw",";");

    $quality=100-abs($ret["onu_rx"]);
    if($quality>=80 and $quality<=100){
        $quality="green";
    }elseif($quality>=74 and $quality<=79){
        $quality="yellow";
    }else{
        $quality="red";
    }
    $ret["onu_quality"]=$quality;

    $ret["onu_vendor"]=code_cut($r,"vendor-id",";");
    $ret["onu_serial"]=code_cut($r,"serial-number",";");
    $ret["onu_eq"]=code_cut($r,"eq-id",";");
    $ret["onu_fw_version"]=code_cut($r,"active-fw",";");
    $ret["onu_fw_status"]=code_cut($r,"software-download-state",";");
    $ret["onu_fw_progress"]=code_cut($r,"software-download-progress",";");
    if($ret["onu_fw_progress"]=="-1"){
        $ret["onu_fw_progress"]="";
    }else{
        $ret["onu_fw_progress"]=$ret["onu_fw_progress"]."% | ";
    }

    $ret["onu_uptime"]=str_replace("day",'dia',str_replace('"',"",str_cut($r,"uptime",";")));
    $ret["onu_distance"]=str_clear(str_cut($r,"distance",";"),"num").' km';


    $eth[0]=code_cut($r,"veip 1","\n}");
    $eth[1]=code_cut($r,"ethernet 1","\n}");
    $eth[2]=code_cut($r,"ethernet 2","\n}");
    $eth[3]=code_cut($r,"ethernet 3","\n}");
    $eth[4]=code_cut($r,"ethernet 4","\n}");
 
    $ret["onu_model"]=$ret["onu_vendor"]." | ".$ret["onu_eq"];
    $ret["onu_fw"]=$ret["onu_fw_version"];
    
    
    //////////////
    $state="";
    $fw_status_color="red";
    if($ret["onu_status"]=="Down"){
        $ret["onu_model"]="";
        $ret["onu_fw"]="";
        $state='Off-Line';
        if($ret["onu_serial"]!=""){
            $state="Rebootando";
        }
    }else{
        $state=$ret["onu_fw_progress"].$ret["onu_fw_status"];
    }

    $ret["onu_fw_status_color"]="";
    $ret["onu_state"]=$state;
    /////////////////////////
    
    $d="Down";
    $u="Up";
  

   
    for ($i=0; $i <=4 ; $i++) { 
        $iface="eth".$i."_";
        $ret[$iface."speed"]=$d;
        $ret[$iface."speedx"]="";
        $ret[$iface."status"]=code_cut($eth[$i],"link",";");
        if($ret[$iface."status"]==$u){
            $speed=code_cut($eth[$i],"negotiatedSpeed",";");
            $duplex1=code_cut($eth[$i],"negotiatedDuplex",";");
            $ret[$iface."speed"]=$speed.'Mbps - '.$duplex1;
            $duplex2=code_cut($eth[$i],"Full-Duplex",";","FDx","HDx");
            $ret[$iface."speedx"]=$speed."Mbps".$duplex2;
        }
    }

    $ret=str_replace('"',"",$ret);
    return $ret;
}
function dm_onu_status($olt,$pon,$onu){
    //die($olt);
    //$ret=ERR_05;
    
        $last_update=date('Y-m-d H:i:s');

        $cmd1='show interface gpon '.$pon.' onu '.$onu.' | nomore | display keypath ; ';
    
        $r=dm_cmd($olt,$cmd1);
        $ret["last_update"]=$last_update;
        $ret["onu_status"]=str_cut($r,"oper-state","\n");
        $ret["name"]=str_replace("_"," ",str_cut($r,"/name","\n"));

        $ret["rx"]=str_cut($r,"/rx-optical-pw","\n");
        $ret["tx"]=str_cut($r,"/tx-optical-pw","\n");
  
        $ret["vendor"]=str_cut($r,"/vendor-id","\n");
        $ret["serial"]=str_cut($r,"/serial-number","\n");
        $ret["model"]=str_cut($r,"eq-id","\n");
        $ret["fw"]=str_cut($r,"active-fw","\n");
        $ret["fw_status"]=str_cut($r,"/software-download-state","\n");

        $ret["uptime"]=str_replace("day",'dia',str_replace('"',"",str_cut($r,"uptime","\n")));
        $ret["distance"]=str_cut($r,"distance","\n").' km';
        
        $mix=str_cut($r,"/ethernet{1}","/link");
        $mb="Mbps - ";

        $ret["ether1_status"]=str_cut($r,"/ethernet{1}".$mix."/link","\n");
        if($ret["ether1_status"]!="Up"){
            $mb="";
        }
        $ret["ether1_speed"]=str_cut($r,"/ethernet{1}".$mix."/negotiatedSpeed","\n").$mb.str_cut($r,"/ethernet{1}".$mix."/negotiatedDuplex","\n");
        
        $ret["ether2_status"]=str_cut($r,"/ethernet{2}".$mix."/link","\n");
        if($ret["ether2_status"]!="Up"){
            $mb="";
        }
        $ret["ether2_speed"]=str_cut($r,"/ethernet{2}".$mix."/negotiatedSpeed","\n").$mb.str_cut($r,"/ethernet{2}".$mix."/negotiatedDuplex","\n");

        $ret["ether3_status"]=str_cut($r,"/ethernet{3}".$mix."/link","\n");
        if($ret["ether3_status"]!="Up"){
            $mb="";
        }
        $ret["ether3_speed"]=str_cut($r,"/ethernet{3}".$mix."/negotiatedSpeed","\n").$mb.str_cut($r,"/ethernet{3}".$mix."/negotiatedDuplex","\n");

        $ret["ether4_status"]=str_cut($r,"/ethernet{4}".$mix."/link","\n");
        if($ret["ether4_status"]!="Up"){
           $mb="";
        }
        $ret["ether4_speed"]=str_cut($r,"/ethernet{4}".$mix."/negotiatedSpeed","\n").$mb.str_cut($r,"/ethernet{4}".$mix."/negotiatedDuplex","\n");
        return $ret;
    
}
function dm_onu_eth_ips($olt,$pon,$onu,$eth){
    $ret1=ERR_05;
    $qtlines=1;
    if($olt!="" or $pon!="" or $onu!=""){
        $cmd1="";
        $cmd2="";
        $cmd1=$cmd1.'show interface gpon '.$pon.' onu '.$onu.' ethernet '.$eth.' | nomore ;';
        $cmd1=$cmd1.'show running-config service-port gpon onu '.$onu.' | nomore ;';
        $ret=dm_cmd($olt,$cmd1);
        $nvlan=code_cut($ret,"Native","\n");
        $nvlan=code_cut($nvlan,":","/");
        preg_match_all('#\nservice(.*?)\n!#s', $ret, $lines);
        $qtlines=sizeof($lines[0]);
        for ($i=0; $i < $qtlines; $i++) { 
            $v=$lines[0][$i];
            $sp=code_cut($v,"service-port","\n");
            if(strpos($v,"gpon ".$pon." onu")!==false){
                if($nvlan!="" and strpos($v,"vlan-id ".$nvlan."\n")!==false){
                    $cmd2='show allowed-ip interface service-port-'.$sp.' | nomore | include "service-port";';
                    break;           
                }else{
                    $cmd2=$cmd2.'show allowed-ip interface service-port-'.$sp.' | nomore | include "service-port";';
                }
                    
            }
            
        }
        $ret=dm_cmd($olt,$cmd2);
        $ret=preg_replace('/( )+/', " ",$ret);
        $ret=preg_replace("#\r#","",$ret);
        $lines=preg_split("#\n#",$ret);
        $qtlines=sizeof($lines);
        $ret1="";
        
        for ($i=0; $i < $qtlines-1; $i++) { 
            $opc='<input type="radio" name="opc" id="'.($i+1).'">';
            $line=$lines[$i];
            $arr_line=preg_split('# : #',$line);    
            $ret1=$ret1.$opc.$line."\n";
        }

    }
    $ret2["ret"]=$ret1;
    $ret2["qt"]=$qtlines-1;
    return $ret2;
}
function dm_onu_eth_macs($olt,$pon,$onu,$eth){
    $ret=ERR_05;
    $qt=0;

    if($olt!="" or $pon!="" or $onu!=""){
        $cmd1="";
        $cmd2="";
        $cmd1=$cmd1.'show interface gpon '.$pon.' onu '.$onu.' ethernet '.$eth.' | nomore ;';
        $cmd1=$cmd1.'show running-config service-port gpon onu '.$onu.' | nomore ;';
        $ret=dm_cmd($olt,$cmd1);
        
        $nvlan=code_cut($ret,"Native","\n");
        $nvlan=code_cut($nvlan,":","/");
        preg_match_all('#\nservice(.*?)\n!#s', $ret, $lines);
        $qtlines=sizeof($lines[0]);
        for ($i=0; $i < $qtlines; $i++) { 
            $v=$lines[0][$i];
            $sp=code_cut($v,"service-port","\n");
            if(strpos($v,"gpon ".$pon." onu")!==false){
                if($nvlan!="" and strpos($v,"vlan-id ".$nvlan."\n")!==false){
                    $cmd2='show mac-address-table interface service-port-'.$sp.' vlan '.$nvlan.'| nomore | include "service-port" ;'."\n";
                    break;           
                }else{
                    $cmd2=$cmd2.'show mac-address-table interface service-port-'.$sp.' | nomore | include "service-port" ;'."\n";
                }
                    
            }
            
        }
        $ret=dm_cmd($olt,$cmd2);
        $ret=preg_replace('/( )+/', " ",$ret);
        $qt=substr_count($ret,"\n");
    }
    $result["ret"]=$ret;
    $result["qt"]=$qt;
    return $result;
}

function dm_onu_log($olt,$pon,$onu){
 
    //$cmd='show log | nomore | include "3/59\r|3/59\n|\(3\/59\)"';
    $ret=ERR_05;
    if($olt!="" or $pon!="" or $onu!=""){
        $arr_chassis=explode("/",$pon);
        $ponx=$arr_chassis[2];
        $onux1=$ponx."/".$onu;
        $onux2='gpon-'.$pon."/".$onu;
        $onux3='UNI\ [(]'.$pon."/".$onu."/";
        $cmd='show running-config service-port gpon onu '.$onu.' | nomore ;';
        $ret=dm_cmd($olt,$cmd);
        
        $cmd1='show log | nomore | include "[(]'.$onux1.'[)]|'.$onux2.'$|'.$onux2.'\ |'.$onux3;
        preg_match_all('#service(.*?)\n!#s', $ret, $lines);

        $qtlines=sizeof($lines[0]);
        $cmd2="";
        for ($i=0; $i <= $qtlines-1; $i++) { 
            $v=$lines[0][$i];
            $sp=code_cut($v,"service-port","\n");
            if(strpos($v,"gpon ".$pon." onu")!==false){
                $cmd2=$cmd2.'|service-port-'.$sp.'\ |service-port-'.$sp.'$';
            }
            
        }
        $cmd=$cmd1.$cmd2.'" ;';
        $ret=dm_cmd($olt,$cmd);
        $ret=preg_replace("#\r#","",$ret);
        $lines=preg_split("#\n#",$ret);
        $qtlines=sizeof($lines);
        $ret2="";
        
        for ($i=0; $i < $qtlines-1; $i++) { 
            $opc='<input type="radio" name="opc" id="'.($i+1).'">';
            $line=$lines[$i];
            $arr_line=preg_split('# : #',$line);    
            $ret2=$ret2.$opc.$arr_line[0]." : ".$arr_line[1]." : ".$arr_line[4]."\n";
        }
    }
    return $ret2;
}

function dm_onu_reboot($olt,$pon,$onu){
    $cmd="config\ninterface gpon ".$pon." ; onu-reset onu ".$onu." ; top ;";
    dm_cmd($olt,$cmd);

}
////-------------------------------------
$err_color="#66ff99";
$err="ERR";

$p=$_POST;
$debug="<pre>".print_r($p,true)."</pre>";
$text="Função não encontrada ou nao especificada<br>".$debug;
$log="";

$code="";
$post="";




$log="<pre>".print_r($p,true)."</pre>";

$text="<div id='dg_1'>Falta preencher opcoes do Formulario</div>";



$cmd=(isset($p["cmd"])?$p["cmd"]:"");
$olt=(isset($p["olt"])?$p["olt"]:"");
$pon=(isset($p["pon"])?$p["pon"]:"");
$onu=(isset($p["onu"])?$p["onu"]:"");
$eth=(isset($p["eth"])?$p["eth"]:"");
$opc=(isset($p["opc"])?$p["opc"]:"");
$help=(isset($p["help"])?$p["help"]:"");

if (PHP_SAPI === 'cli') {
    $olt="4707840";
//    $olt="4581256";
    $pon="1/1/2";
    $onu="41";
    $eth="1";
    $cmd="onu_status";
    $cmd="onu_status_ips";
    $cmd="onu_log";
    $cmd="onu_fw_list";


    $p["onu_model"]='DACM | DM984-100B';
    //$cmd="onu_reboot";
  //  $cmd="onu_status_ethernet-1";
    
}
if($cmd=="help"){
    $html=help($help,$opc);
    //$html='Isto e um teste';
}



if ($cmd=="onu_status"){
    $ret=dm_onu_status2($olt,$pon,$onu);
    $log=print_r($ret,true);
    $text="<pre>".code2html($log)."</pre>";
    $post=print_r($ret,true);
    $retarray=$ret;
}

if($cmd=="onu_status_macs"){
    $ret=dm_onu_eth_macs($olt,$pon,$onu,$eth);

    $title='<span style="color: yellow;">'.$ret["qt"].'</span> MACs verificados na Interface ETH #'.$eth;
    $html=code2html('<code>'.$ret["ret"].'<code>');
    $help='Endereços MACs aprendidos na Interface Associada ao Service-Port';
}
if($cmd=="onu_status_ips"){
    $ret=dm_onu_eth_ips($olt,$pon,$onu,$eth);
    $title='<span style="color: yellow;">'.$ret["qt"].'</span> IPs verificados na Interface ETH #'.$eth;
    $help='Endereços IPs percebidos na Interface Associada ao Service-Port';
    $html=code2html('<code>'.$ret["ret"].'<code>');
}
if($cmd=="onu_log"){
    $err="";
    $ret=dm_onu_log($olt,$pon,$onu);
    $title='Verificando Logs na ONU: '.$pon."-".$onu;
    $text="Isto e um teste";
    $html=code2html('<code>'.$ret.'<code>');
    $js=js_btshow("Continuar",false);

}
if($cmd=="onu_reboot"){
    if($opc=="opc_check"){
        //$help="Reinicia a ONU<br>Aprox. 2min";
        $opc="opc_reboot";
        $title="Reiniciar";
        $html=html_format("orange",'Reiniciar a ONU '.$pon.'-'.$onu.' do Sistema ?');
    }elseif($opc=="opc_reboot"){
        dm_onu_reboot($olt,$pon,$onu);
        //$html=html_format("red","Rebotando onu em ".$pon."-".$onu);
        $cmd="close";
    }
}
if($cmd=="onu_fw"){
    $form=form_decode($p["form"]);
    $onu_model=str_replace(' | ','-',(isset($p["onu_model"])?$p["onu_model"]:""));
    $fw_array=explode("|",$form["opc_fw"]);
    $fw=$fw_array[0];
    $md5=$fw_array[1];
    if($opc=="opc_list"){
        $title="Escolha um dos Firmwares para Fazer a Atualizacao";
        $help="Os Firmwares disponiveis sao listados abaixo.<br>Todos os arquivos foram baixados diretamente do site da DATACOM";
        $ret=dm_onu_fw_list($onu_model);
        
        if($ret==""){
            $ret=ERR_ONU_FW_CHECK_NOT;
            //$js=js_header(5000,$ret);
     
            //$js=js_alert_info("terra",ERR_ONU_FW_CHECK_NOT);
            $js=js_btshow("Continuar",false).js_btshow("Help",false);

            //$js=js_bttitle("Continuar","Outro");
            $html=html_format('coral','Nao existe Firmware para esta ONU');

        }else{
            $ret="<code>".$ret."</code>";
            $opc="opc_check";
            $html=$ret;   
        }
    }
    elseif($opc=="opc_check"){
         if($fw==""){
            $js=js_header(5000,ERR_ONU_FW_CHECK_NO);
        }else{
            $opc="opc_check_exist";
            $run=true;
            $title="Verificando MD5 do arquivo";
            $html="<code>&raquo; Checando integridade MD5 do Arquivo</code><br>";
        }
    }elseif($opc=="opc_check_exist"){
        $title="Firmware pronto para atualização";
        $ahtml='Check: '.$md5;
        $olt_cmd='show firmware onu | nomore | tab | csv ; "';
        $ret=dm_cmd($olt,$olt_cmd);
        if(strpos($ret,",".$fw.",".$md5)!==false){
            $ahtml="<code>&raquo; Firmware já existe na OLT<br><br>Deseja Atualizar ?</code><br>";
            $opc="opc_install";
        }else{
            $ahtml='<code>&raquo; Baixando para a OLT. Aguarde o Termino...</code><br>';
            $opc="opc_download";
            $run=true;
        }
    }elseif($opc=="opc_download"){
        $title="Download do Firmware para a OLT";
        $olt_cmd="";
        $olt_cmd='request firmware onu add tftp://'.TFTP_SERVER."/".$onu_model."/".$fw;
        $ret=dm_cmd($olt,$olt_cmd);
        $ahtml="<code>&raquo; ".$ret."</code><br>";
        $ahtml=$ahtml."<code>&raquo; Download Concluido!<br><br>Deseja Atualizar ? </code><br>";
        $opc="opc_install";
        
    }elseif($opc=="opc_install"){
        $title="Instalando arquivo de Firmware na ONU";
        $ahtml="<code>&raquo; Instalando #1 - ".$pon.":".$onu." com ".$fw."<br></code>";
        $opc="opc_install7";
        $run=true;
    }elseif($opc=="opc_install2"){
        $title="Instalando arquivo de Firmware na ONU";
        $olt_cmd="";
        //$olt_cmd=$olt_cmd.'request firmware onu add tftp://'.TFTP_SERVER."/".$onu_model."/".$fw.' ;';
        $olt_cmd=$olt_cmd.'request firmware onu install '.$fw.' interface gpon '.$pon.' onu '.$onu.' ;';
        $ret=dm_cmd($olt,$olt_cmd);
        $ahtml=$ahtml."<code>&raquo; Instalando #2 - ".$pon.":".$onu." com ".$fw."<br></code>";
        $ahtml=$ahtml."<code>&raquo; Firmware Pronto. Aguarde Finalização.<br></code>";
        $ahtml=$ahtml."<code>&raquo; Pressione Continuar para Sair<br></code>";
        $cmd="close";

    }
    elseif($opc=="opc_install7"){
        sleep(8);
        $title="zzzzInstalando arquivo de Firmware na ONU";
        $ahtml=$ahtml."<code>&raquo; Pressione Continuar para Sair<br></code>";
        $opc="opc_install7";
        //$cmd="close";
        $run=true;

    }
}


$retarray["cmd"]=$cmd;
//$retarray["err"]=$err;
//$retarray["err_color"]=$err_color;
if($js!=""){
    $js="<script>".$js."</script>";
}
if($html!=""){
    $html='<div id="js"></div><div id="html_head"></div><div id="html_body">'.$html."</div>";
}
$retarray["title"]=$title;
$retarray["text"]=$text;
$retarray["html"]=$html;
$retarray["ahtml"]=$ahtml;
$retarray["js"]=$js;
$retarray["opc"]=$opc;
$retarray["run"]=$run;
$retarray["code"]=$code;
$retarray["log"]=$log;
$retarray["post"]=$p;
$retarray["help"]=$help;
$retarray["last_update"]=date('Y-m-d H:i:s');
echo json_encode($retarray);
?>